﻿/********************************************************************************/
/* 	state.d																		*/
/*------------------------------------------------------------------------------*/
/*	製作		瓦千鳥（あるふぁ～秘密基地）									*/
/*	製作開始	2011/07/01														*/
/*	MAIL		dij@estate.ocn.ne.jp											*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2011/07/**	初版															*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

/* ライブラリのインポート *******************************************************/
private import hell2;		// dHell2ライブラリ
private import vector;
private import keypad;
private import actor;
private import clickable;
private import gamecore;

private import std.string;
private import std.math;
private import std.math2;
private import std.stream;
private import std.thread;

import config;

/* グローバル定数定義 ***********************************************************/
GameState g_gamestate = null;


/* load *************************************************************************/
/*	リソースの読み込み															*/
/*-引数-------------------------------------------------------------------------*/
/*	なし																		*/
/*-返り値-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/
void load()
{
	Hell_loadTexture("font","resource/font/font.bmp" , [255,255,255]);
//	Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);
//	Hell_loadWAV("up",      "resource/sound/jump.wav");
	Hell_loadWAV("yell",    "resource/sound/ok.wav");
	Hell_loadWAV("cancel",  "resource/sound/msg.wav");
	Hell_loadWAV("select",  "resource/sound/select.wav");
	
	Hell_loadWAV("exit",    "resource/sound/l1.wav");
	Hell_loadWAV("lvup",    "resource/sound/pp_lvup_j.wav");
	Hell_loadWAV("absorb",  "resource/sound/pp_absorb_j.wav");
	Hell_loadWAV("clear",   "resource/sound/pp_clear_j.wav");
	Hell_loadWAV("enemy1",  "resource/sound/pp_enemy_j01.wav");
	Hell_loadWAV("enemy2",  "resource/sound/pp_enemy_j02.wav");
	Hell_loadWAV("enemy3",  "resource/sound/pp_enemy_j03.wav");
	Hell_loadWAV("drop",    "resource/sound/pp_get_j.wav");
	Hell_loadWAV("tired",   "resource/sound/pp_tired_j.wav");

	Hell_loadWAV("break1",  "resource/sound/mm_break1.wav");	//武器劣化
	Hell_loadWAV("break2",  "resource/sound/mm_break2.wav");	//武器大破
	Hell_loadWAV("atk1",    "resource/sound/mm_atk1.wav");		//攻撃
	Hell_loadWAV("atk2",    "resource/sound/mm_atk2.wav");		//攻撃(敵)
	Hell_loadWAV("arms_sel","resource/sound/mm_select.wav");
	Hell_loadWAV("arms_not","resource/sound/msg.wav");
	Hell_loadWAV("up",      "resource/sound/mm_up.wav");
	Hell_loadWAV("down",    "resource/sound/mm_down.wav");
	Hell_loadWAV("win",     "resource/sound/mm_win.wav");
	Hell_loadWAV("lose",    "resource/sound/mm_lose.wav");
	Hell_loadWAV("runaway", "resource/sound/mm_runaway.wav");

	
	Hell_write("resource loaded.\n");
}

/* GameState ********************************************************************/
/*	ゲーム全体の状態遷移を管理するクラス										*/
/********************************************************************************/
class GameState
{
private:
	int msg;				// リクエストメッセージ
public:
	enum
	{
		MSG_NONE = 0,
		MSG_REQ_LOGO,			// ロゴ状態へ　行きたい
		MSG_REQ_TITLE,			// タイトル状態へ　行きたい
		MSG_REQ_GAME,			// ゲーム
		
		MSG_EXIT,				//アプリケーションの終了
	}
	
	void move(){}
	void draw(){}
	
	// 設定
	void setMsg(int m)
	{
		msg = m;
	}
	// 取得
	int getMsg()
	{
		return msg;
	}
}



bool loop()
{
	bool is_exit = true;	//アプリケーションの終了
	if(g_gamestate)
	{
		// メッセージ指示による状態遷移
		switch(g_gamestate.msg)
		{
			case GameState.MSG_NONE:
				break;
			case GameState.MSG_REQ_LOGO:
				g_gamestate = new LogoMain();
				break;
			case GameState.MSG_REQ_TITLE:
				g_gamestate = new TitleMain();
				break;
			case GameState.MSG_REQ_GAME:
				g_gamestate = new GameMain();
				break;
			case GameState.MSG_EXIT:
			default:
				is_exit = false;
				Hell_write("Unknown msg at loop.");
		}
	}
	else
	{
		// 初期状態
		g_gamestate = new LogoMain();
		Hell_write("Exec loop.\n");
	}
	
	g_gamestate.move();
	g_gamestate.draw();
	
	return( is_exit );
}

/* TitleMain ********************************************************************/
/*	タイトルの状態																*/
/********************************************************************************/

class TitleMain : GameState
{
public:
	int timer;
	Keypad keypad;					// キーボード/ゲームパッド取得用
	int init_flag;
	ConfigParser savedata;			// セーブデータ
	int hi_score[10];
	int count =  60*60*0;			//カウンター初期値
	int count_max = 0;				//カウンターMAX初期値
	int lock = 0;					//カウンターのスタート/ストップ
	int exp_timer = 0;				//カウンターを回す間加算し経験値を算出
	int bonus_chance = 1;			//ストップボーナスの回数。
	int exp_main = 0;				//基礎経験値
	int exp_up = 100;				//基礎経験値に対する倍率 数字扱い上100％で表示
	int exp_bonus = 0;				//基礎経験値に対するボーナス
	int exp_bonus2 = 0;				//基礎経験値に対するボーナス比較
	int exp_bonus3 = 0;				//戦闘勝利ボーナス
	int player_exp = 0;				//主人公_経験値
	int player_lv = 1;				//主人公_LEVEL
	int state_hp = 50;				//主人公_生命力
	int state_mp = 10;				//主人公_気力
	int state_RES = 100;			//主人公_
	int state_atk = 100;			//主人公_攻撃
	int state_def = 100;			//主人公_防御
	int state_spd = 100;			//主人公_スピード
	int player_hp = 50;				//主人公_生命力 MAX表示
	int player_mp = 10;				//主人公_気力 [不要？]
	int player_RES = 0;				//主人公_
	int player_atk = 3;				//主人公_攻撃
	int player_def = 3;				//主人公_防御
	int player_spd = 3;				//主人公_スピード
	int player_act = 0;				//主人公_状態
	int spd = 15;					//アニメスピード
	float ani_size = 1;				//アニメサイズ
	int enemy_lv = 0;				//敵_LEVEL
	int enemy_hp = 50;				//敵_生命力
	int enemy_atk = 3;				//敵_攻撃
	int enemy_def = 3;				//敵_防御
	int enemy_spd = 3;				//敵_スピード
	int enemy_type;					//敵_種類
	float enemy_size;				//敵_サイズ
	float b_spd;					//戦闘速度比較
	int b_dmg;						//戦闘打撃比較
	int atk_count;					//戦闘モーション　主人公用
	int eatk_count;					//戦闘モーション　敵用
	int b_count;					//戦闘カウンタ　主人公用
	int e_count;					//戦闘カウンタ　敵用
	int r_count;					//戦闘カウンタ イベント、リセット用
	int enemy_count = 300;			//戦闘エンカウント率調整用
	int damage_count;				//ステータス影響確定用1
	int yell_count;					//ステータス影響確定用2
	int target;						//ターゲットON
	int map_l = 20;					//マップ表示位置調整
	int map_x;						//マップX
	int map_y;						//マップY
	int roop_i;						//汎用ループ
	int map_lock = 12;				//マップ選択
	int map[100];					//マップ　レベル情報
	int get[100];					//マップ　攻略情報
	int arms[15];					//武器情報　　11***種類　**111攻撃防御速さ
	int arms_lock;					//武器決定用
	int arms_atk;
	int arms_def;
	int arms_spd;
	int arms_type;
	int arms_r;
	int arms_b;
	int arms_g;
	int absorb_count;				//吸収エフェクト用
	int swap_a;						//マップ、シャッフル用
	int swap_b;
	int swap_c;
	int text_p = 0;
	char[] str;

	//koizumi start
	int bg_count = 0;				//ＢＧスクロール制御
	int bg_type = 0;				//ＢＧタイプ
	//koizumi end
	
	//追加要素
	int t_search;					//トータル探索時間
	int t_battle;					//トータル戦闘回数

	int test;						//デバッグ用

	int star;
	int maxstar;
	int sel ;
	
	
	//エフェクト用構造体
	struct EFFECT_DATA
	{
		int exist;	//存在
		int type;	//透明度
		int timer;	//生存時間
		float pos_x;//位置
		float pos_y;//位置
		int r;	//
		int g;	//
		int b;	//
		int alpha;	//透明度
		float dir;	//方向
		float speed;//速度
		float zoom_x;	//
		float zoom_y;	//
	};
	const int EFFECT_MAX = 128;
	EFFECT_DATA effect[EFFECT_MAX];
	
	
	this()
	{
Hell_write( "TitleMain\n" );
		setMsg( GameState.MSG_NONE );
		timer = 0;
		init_flag = 0;
		star = 0;

		Hell_loadTexture("player","resource/image/player.bmp" , [0,255,0]);

		Hell_loadTexture("enemy","resource/image/enemy.bmp" , [0,255,0]);

		Hell_loadTexture("bg01","resource/image/bg03.bmp" , [0,255,0]);

		Hell_loadTexture("bg02","resource/image/bg02.bmp" , [0,255,0]);

		Hell_loadTexture("bg03","resource/image/bg03.bmp" , [0,255,0]);

		Hell_loadTexture("bg04","resource/image/bg04.bmp" , [0,255,0]);

		Hell_loadTexture("bg05","resource/image/bg05.bmp" , [0,255,0]);
		
		// koizumi start
		//エフェクト画像を追加
		Hell_loadTexture("effect","resource/image/effect_ball.bmp" , [0,255,0]);
		// koizumi end


		keypad = new Keypad();
		//セーブデータ
		hi_score[0] = 0;
		savedata = new ConfigParser();
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("EXP",         0);
			savedata.set("LV",          1);
			savedata.set("HP",          50);
			savedata.set("MP",          10);
			savedata.set("ATK",         100);
			savedata.set("DEF",         100);
			savedata.set("SPD",         100);
			savedata.set("T_SEARCH",    0);
			savedata.set("T_BATTLE",    0);
			
			for ( roop_i = 0 ; roop_i <= 24 ; roop_i++ )	//マップ配置
			{
				map[roop_i] = roop_i;
				get[roop_i] = 0;
			}
			for ( roop_i = 0 ; roop_i <= 100 ; roop_i++ )	//シャッフル
			{
				swap_a = Hell_randInt(0, 25);
				swap_b = Hell_randInt(0, 25);
				swap_c = map[swap_a];
				map[swap_a] = map[swap_b];
				map[swap_b] = swap_c;
			}
			for ( roop_i = 0 ; roop_i <= 700 ; roop_i++ )	//シャッフル2
			{
				swap_a = Hell_randInt(0, 25);
				swap_b = Hell_randInt(0, 25);
				swap_c = map[swap_a];
				map[swap_a] = map[swap_b];
				map[swap_b] = swap_c;
				if ( map[12] == 0 )
				{
					roop_i=1000;
				}
			}
			for ( roop_i = 0 ; roop_i <= 24 ; roop_i++ )	//マップ記録
			{
				str = std.string.format( "MAP%02d", roop_i );
				savedata.set( str , map[roop_i]);
				str = std.string.format( "GET%02d", roop_i );
				savedata.set( str , get[roop_i]);
			}


			arms[0] = 1333;		//初期武器
			for ( roop_i = 0 ; roop_i <= 9 ; roop_i++ )	//武器記録
			{
				str = std.string.format( "ARMS%02d", roop_i );
				savedata.set( str , arms[roop_i]);
			}

			savedata.write();
		}
		player_exp = savedata.getint("EXP");
		player_lv = savedata.getint("LV");
		state_hp = savedata.getint("HP");
		state_mp = savedata.getint("MP");
		state_atk = savedata.getint("ATK");
		state_def = savedata.getint("DEF");
		state_spd = savedata.getint("SPD");
		t_search = savedata.getint("T_SEARCH");
		t_battle = savedata.getint("T_BATTLE");
		
		for ( roop_i = 0 ; roop_i <= 24 ; roop_i++ )	//マップ読込
		{
			str = std.string.format( "MAP%02d", roop_i );
			map[roop_i] = savedata.getint( str );
			str = std.string.format( "GET%02d", roop_i );
			get[roop_i] = savedata.getint( str );
		}
		for ( roop_i = 0 ; roop_i <= 9 ; roop_i++ )	//武器読込
		{
			str = std.string.format( "ARMS%02d", roop_i );
			arms[roop_i] = savedata.getint( str );
		}
	}
	
	void move()
	{
		if ( init_flag == 0 )
		{
			init_flag = 1;
//			Hell_loadTexture("title","resource/image/title.bmp" , [0,255,0]);
//			Hell_playBgm( "resource/sound/title.ogg", -1, 0 );
			Hell_stopBgm( 1000 );
		}
		timer++;
		if ( timer >= spd * 8 * 15)
		{
			timer = spd *8 *5;
		}
		
		if ( atk_count > 0 )
		{
			atk_count = atk_count - 1;
		}
		if ( b_count > 0 )
		{
			b_count = b_count - 1;
		}
		else if ( player_act == 4 )
		{
			b_count = 0;
			player_act = 5;
			atk_count = 24;
		}
		if (( atk_count == 0 ) && ( player_act == 5 ))
		{
			b_spd = (enemy_spd / player_spd);
			if ( b_spd >5 )
			{
				b_spd = 5;
			}
			else if ( b_spd < 1 )
			{
				b_spd = 1;
			}
			
			b_count = cast(int)(100 * b_spd);	//攻撃終了
			player_act = 4;
			b_dmg = ( player_atk - enemy_def ) ;
			if ( b_dmg < 0 )
			{
				b_dmg = 0;
			}
			b_dmg = b_dmg + (Hell_randInt(0, player_lv/10 + 2));	//かすり補正
			enemy_hp = enemy_hp - b_dmg ;
		}

		if ( eatk_count > 0 )
		{
			eatk_count = eatk_count - 1;
		}
		if ( e_count > 0 )
		{
			e_count = e_count - 1;
		}
		else if ( ( eatk_count == 0 ) && ( (player_act == 4) || (player_act == 5) ) )
		{
			e_count = 0;
			eatk_count = 24;
		}
		if ( ( eatk_count == 1) && ( (player_act == 4) || (player_act == 5) ) )
		{
			b_spd = (player_spd / enemy_spd);
			if ( b_spd >5 )
			{
				b_spd = 5;
			}
			else if ( b_spd < 1 )
			{
				b_spd = 1;
			}
			
			e_count = cast(int)(100 * b_spd);	//攻撃終了
			b_dmg = ( enemy_atk - player_def ) ;
			if ( b_dmg < 0 )
			{
				b_dmg = 0;
			}
			b_dmg = b_dmg + (Hell_randInt(0, enemy_lv/10 + 2));	//かすり補正
			state_hp = state_hp - b_dmg ;
			damage_count = damage_count + b_dmg;
			if ( state_hp <= 0 )														//敵にやられる。
			{
			Hell_stopBgm(300);
				if ( arms_lock >0 )
				{
				arms_down();	//武器の破損、破壊。
				}
			} 
		}
		
		if ( ( enemy_hp <= 0) && ( ( player_act == 4 ) || ( player_act == 5 ) ) )		//敵を倒す。
		{
			Hell_stopBgm(300);
			player_act = 7;		//勝利状態
			enemy_hp = 0 ;
			Hell_playWAV( "win", 0, -1 );
			r_count = 240;
			exp_bonus3 = ((enemy_lv * enemy_lv)-((enemy_lv-1)*(enemy_lv-1)))*1;

			if ( target == 1 )	//ターゲットの場合は経験値4倍
			{
				get[map_lock] = 1;
				exp_bonus3 =exp_bonus3 * 4;
			}
			if ( target == 2 )	//イレギュラーの場合は経験値7倍
			{
				exp_bonus3 =exp_bonus3 * 7;
			}
			player_exp = player_exp + exp_bonus3;
			level_up();

			
			if ( damage_count >= player_hp*2 )	//■■■ステータス変化(怪我)
			{
			state_def = state_def + 3;
			state_spd = state_spd - 1;
			}
			else if ( damage_count >= player_hp )
			{
			state_def = state_def + 2;
			state_spd = state_spd - 1;
			}
			else if ( damage_count >= player_hp/2 )
			{
			state_def = state_def + 1;
			state_spd = state_spd - 1;
			}
			else
			{
			}
			if ( yell_count >= 20 )	//■■■ステータス変化(応援)
			{
			state_atk = state_atk + 3;
			state_def = state_def - 1;
			}
			else if ( yell_count >= 10 )
			{
			state_atk = state_atk + 2;
			state_def = state_def - 1;
			}
			else if ( yell_count >= 5 )
			{
			state_atk = state_atk + 1;
			state_def = state_def - 1;
			}
			else
			{
			}
			player_status();
			
			if ( ( target == 0 ) && ( Hell_randInt(0, 15) == 0 ) ) //武器ドロップ
			{
				arms_drop();
			}
			if ( target > 0 )
			{
				state_mp = state_mp + 7;
				arms_drop();
			}

			state_mp = state_mp + 3;
			if (state_mp > 100 )
			{
				state_mp = 100;
			}
			
		}

		if ( r_count > 0 )
		{
			r_count = r_count - 1;
		}
		else if ( player_act == 6 )	//敗北
		{
			Hell_stopBgm(300);
			Hell_playWAV( "tired", 0, -1 );
			Hell_playBgm( "resource/sound/pp_tired.ogg", -1, 0 );
			player_act = 2;
			r_count = 60*60*3;	//疲労→休憩へ移行
			enemy_count = exp_timer + 300;
			enemy_status();
		}
		else if ( player_act == 7 )	//勝利
		{
			Hell_stopBgm(300);
			player_act = 1;
			enemy_status();
			enemy_count = exp_timer + 300;
		}
		else if ( player_act == 8 )	//逃走
		{
			player_act = 1;
			enemy_status();
			enemy_count = exp_timer + 300;
		}
		else if ( player_act == 2 )
		{
			Hell_stopBgm(300);
			Hell_playBgm( "resource/sound/pp_rest.ogg", -1, 0 );
			player_act = 3;
			enemy_status();
		}
		
		if ( (  player_act == 3 )  && (timer % 60 == 0) && ( player_hp > state_hp ) )
		{
			if ( player_hp / 60 < 1 )
			{
				state_hp++;
			}
			else
			{
				state_hp = state_hp + (player_hp / 60);
			}
			if (state_hp >= player_hp )
			{
				Hell_stopBgm(300);
				state_hp = player_hp;
				player_act = 1;			//探索復帰
			}
			result_save();		//記録処理
		}

		
		player_status();		//状態変化
		arms_status();			//武器状態
		if ( (enemy_lv == 0) || (count == 0) )
		{
			enemy_status();
			state_hp = player_hp;
		}
		
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 6 ) ) //min
		{
			count = count + 600*60;
			Hell_playWAV( "up", 0, -1 );
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_RIGHT) && ( Hell_GetGameflag(10) == 6 ) ) //min
		{
			count = count - 600*60;
			Hell_playWAV( "down", 0, -1 );
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 1 ) ) //min
		{
			count = count + 60*60;
			Hell_playWAV( "up", 0, -1 );
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_RIGHT) && ( Hell_GetGameflag(10) == 1 ) ) //min
		{
			count = count - 60*60;
			Hell_playWAV( "down", 0, -1 );
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 7 ) ) //sec
		{
			count = count + 10*60;
			Hell_playWAV( "up", 0, -1 );
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_RIGHT) && ( Hell_GetGameflag(10) == 7 ) ) //sec
		{
			count = count - 10*60;
			Hell_playWAV( "down", 0, -1 );
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 2 ) ) //sec
		{
			count = count + 1*60;
			Hell_playWAV( "up", 0, -1 );
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_RIGHT) && ( Hell_GetGameflag(10) == 2 ) ) //sec
		{
			count = count - 1*60;
			Hell_playWAV( "down", 0, -1 );
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 3 ) //lock
			&& ( count > 0 ) ) 
		{
			lock = (lock + 1) % 2;
			if ( player_act <=1 )
			{
			player_act = lock;
			}
			Hell_playWAV( "select", 0, -1 );
			result_save();		//記録処理
//			Hell_stopBgm( 0 );
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_RIGHT) && ( Hell_GetGameflag(10) == 3 ) //lock
			&& ( count > 0 ) ) 
		{
			lock = 1;
			count = -1;
			count_max = 0;
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 11 ) ) //MAP lock
		{
			map_x = cast(int)( Hell_getMouseX - map_l );
			map_y = cast(int)( Hell_getMouseY / 20 * 20 - 80);
			map_lock = map_y /20 *5  + map_x /20   ;
			test = map_lock;
			Hell_playWAV( "select", 0, -1 );
			enemy_status();
			
			//koizumi start
			//BGお種類を決定する
			bg_type = map[map_lock] % 5;
			//koizumi end
			
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 15 ) ) //ARMS lock
		{

			if ( arms[(Hell_getMouseX -20) /15] == 0 )	//選択武器がない
			{
				Hell_playWAV( "arms_not", 0, -1 );
			}
			else
			{
				arms_lock = (Hell_getMouseX -20) /15;
				Hell_playWAV( "arms_sel", 0, -1 );
			}
			
			arms_status();
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_RIGHT) && ( Hell_GetGameflag(10) == 15 ) //ARMS absorb
			&&( count == 0 ) && ((Hell_getMouseX -20) /15 == arms_lock ) ) //選択武器と一致している。
		{

			if ( ( Hell_getMouseX -20) /15 > 0 )	
			{
				arms_absorb();
				result_save();
			}
			else
			{
				Hell_playWAV( "down", 0, -1 );
			}
			
			arms_status();
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_RIGHT) && ( Hell_GetGameflag(10) == 15 ) //ARMS shot
			&&( player_act == 4 ) && ((Hell_getMouseX -20) /15 == arms_lock ) ) //選択武器と一致している。
		{
		}

		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 12 )	//YELL 通常時
			&& ( state_hp < player_hp ) && (player_act <= 3 ) && ( lock == 1 ) ) 
		{
			if ( state_mp > 0 )
			{
				Hell_stopBgm(300);
				state_mp = state_mp - 1;
				state_hp = state_hp + (player_hp / 10);	//回復
				Hell_playWAV( "yell", 0, -1 );
				player_act = 1;			//探索復帰
				if ( state_hp > player_hp )
				{
					state_hp = player_hp;
				}
			}
			else
			{
				Hell_playWAV( "down", 0, -1 );
			}
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 12 )	//YELL 戦闘時
			&& ( state_hp < player_hp ) && ((player_act == 4 )||(player_act == 5 )) && ( lock == 1 ) ) 
		{
			if ( state_mp > 0 )
			{
				state_mp = state_mp - 1;
				state_hp = state_hp + (player_hp / 10);	//回復
				yell_count++;
				Hell_playWAV( "yell", 0, -1 );
				if ( state_hp > player_hp )
				{
					state_hp = player_hp;
				}
			}
			else
			{
				Hell_playWAV( "cancel", 0, -1 );
			}
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 13 )	//DASH,REST,RUNAWAY
			&& ( lock == 1 ) )	
		{
			if ( ( ( player_act == 1 ) || ( player_act == 2 ) ) && ( state_hp < player_hp ) )
			{
			Hell_stopBgm(300);
			Hell_playBgm( "resource/sound/pp_rest.ogg", -1, 0 );
			Hell_playWAV( "select", 0, -1 );
			player_act = 3;
			}
			else if ( player_act == 3 )
			{
			Hell_stopBgm(300);
			Hell_playWAV( "select", 0, -1 );
			player_act = 1;
			}
			else if ( player_act == 4 )
			{
			Hell_stopBgm(300);
			Hell_playWAV( "runaway", 0, -1 );
			player_act = 8;		//逃走状態 1割のダメージを受ける。
			state_hp = state_hp*9/10 ;
			r_count = 60;
				if ( enemy_lv >= map[map_lock]*4 +1 )	//■■■ステータス変化(逃走)
				{
				state_atk = state_atk - 1;
				state_spd = state_spd + 3;
				}
				else
				{
				state_atk = state_atk - 1;
				state_spd = state_spd + 1;
				}
			player_status();
			}
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 16 ) )	//text select
		{
			text_p = ( Hell_getMouseY  ) /20 - 3;
			if ( ( text_p < 1 ) || ( text_p > 2 ) )
			{
				text_p = 0;
			}
			else
			{
			Hell_playWAV( "select", 0, -1 );
			}
			test = text_p;
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 17 ) )	//text cancel
		{
			text_p = 0;
			Hell_playWAV( "cancel", 0, -1 );
		}

		if ( ( ( player_act == 1 ) && ( exp_timer % 60 == 0) && ( Hell_randInt(0, 60 ) == 0) && ( exp_timer > enemy_count ))
			|| ( ( player_act == 1 ) && ( exp_timer > enemy_count + 1500 ) ) )
		{				//自動エンカウント
		player_act = 4;
		enemy_status2();
		b_count = 150;	//戦闘時のカウント
		e_count = 150;
		r_count = 120;
		exp_bonus3 = 0;
		damage_count = 0;	//怪我パターン用
		yell_count = 0;		//応援パターン用
		
		Hell_playWAV( "select", 0, -1 );
		}

		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 25 )	//debug
			&& ( count > 0 ) ) //lock
		{
//			player_exp = player_exp + 10000;
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_RIGHT) && ( Hell_GetGameflag(10) == 25 )	//debug
			&& ( count > 0 ) ) //lock
		{
			exp_timer = exp_timer  + 3600;
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 26 )	//debug
			&& ( count > 0 ) ) //lock
		{
			if ( (player_act == 1 )  )
			{
			player_act = 4;
			enemy_status2();
			b_count = 150;	//戦闘時のカウント
			e_count = 150;
			r_count = 120;
			exp_bonus3 = 0;
			damage_count = state_hp;	//怪我パターン用
			yell_count = 0;				//応援パターン用
			
			Hell_playWAV( "select", 0, -1 );
			}
		}
		
		if ( (Hell_isPushMouse() & HELL_BUTTON_RIGHT) && ( Hell_GetGameflag(10) == 26 )	//debug
			&& ( count > 0 ) ) //ENEMY CHANGE
		{
			enemy_status2();
			Hell_playWAV( "select", 0, -1 );
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 27 )	//debug
			&& ( count > 0 ) ) //DROP
		{
			arms_drop();
			arms_status();
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_RIGHT) && ( Hell_GetGameflag(10) == 27 )	//debug
			&& ( count > 0 ) ) //lock
		{
			get[map_lock] = (get[map_lock] + 1) % 2;
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) == 28 )	//debug
			&& ( count > 0 ) ) //lock
		{
			state_hp = state_hp + 10;
		}
		if ( (Hell_isPushMouse() & HELL_BUTTON_RIGHT) && ( Hell_GetGameflag(10) == 28 )	//debug
			&& ( count > 0 ) ) //lock
		{
			state_hp = state_hp - 10;
		}

		if(keypad.isPushLeft())
		{
		}
		else if(keypad.isPushRight())
		{
		}
		if (keypad.isPushUp())
		{
		}
		else if(keypad.isPushDown())
		{
		}

		
		if ( count <= 0 )								//★タイマーリセット状態
		{
			player_act = 0;
			if ( exp_timer > 0 )
			{
				lock = 0;
				Hell_stopBgm(300);

				if ( count == 0 )
				{
				Hell_playWAV( "clear", 0, -1 );	
				}
				else
				{
				Hell_playWAV( "exit", 0, -1 );	
				}

				level_up();

				exp_main = 0;		//リセット
				exp_timer = 0;		//リセット
				count_max = 0;		//リセット
				bonus_chance = 1;	//リセット
				b_count = 0;		//リセット
				e_count = 0;		//リセット
				enemy_count = 300;	//リセット
				state_hp = player_hp;

				result_save();		//記録処理

			}
			else if ( lock == 1 )
			{
				lock = 0;
				Hell_playWAV( "select", 0, -1 );
				result_save();		//記録処理
			}
		count = 0;
		}
		else if ( ( lock == 1 ) && ( count > 0 ) )		//★タイマー起動状態
		{
			count--;
			if (player_act == 1)
			{
				exp_timer++;
			}
			if ( exp_timer > 100*60*60-1 )	//カウンター上限
			{
				exp_timer = 100*60*60-1;	//終了処理準備
				count = 0;					//終了処理準備
			}
			exp_up = ((360000 *100) /(360000 - exp_timer));	//反比例ボーナス
			if (exp_up >1000 )
			{
				exp_up = 1000;								//ボーナス倍率上限　1000%(10倍)
			}
			if ( ( exp_timer % 600 == 0 ) && (state_hp > 0) && (player_act == 1 ) )
			{
				player_exp = player_exp + 1;					//経験値 10秒で＋１
				exp_main = exp_timer / 600;						//基礎経験値　加算
				state_hp --;
				level_up();
				result_save();		//記録処理
			}
			if ( ( state_hp <= 0) && ( player_act == 1 ) )		//動けなくなる。
			{
				Hell_stopBgm(300);
				Hell_playWAV( "tired", 0, -1 );
				Hell_playBgm( "resource/sound/pp_tired.ogg", -1, 0 );
				player_act = 2;		//疲労状態
				r_count = 60*60*3;	//疲労→休憩へ移行
			}
			if ( ( state_hp <= 0) && ( ( player_act == 4 ) || ( player_act == 5 ) ) )		//動けなくなる。
			{
				Hell_stopBgm(300);
				player_act = 6;		//敗北状態
				state_hp = 0 ;
				Hell_playWAV( "lose", 0, -1 );
				r_count = 60;
			}

			exp_bonus = (exp_main * exp_up)/100 - exp_main;		//経験値ボーナス計算

			if (exp_bonus > exp_bonus2 )
			{
				player_exp = player_exp + ( exp_bonus - exp_bonus2);
				exp_bonus2 = exp_bonus;
				state_mp ++;
				level_up();
				if (state_mp > 100 )
				{
					state_mp = 100;
				}
				result_save();		//記録処理
			}
		}
		else											//★タイマー停止状態
		{
//			player_act = 0;
		}
		
		if ( count > 100*60*60-1 )	//カウンター上限
		{
			count = 100*60*60-60;
		}
		
		if ( count_max < count ) //カウンター設定上限 ★ストップボーナスに利用予定。
		{
			count_max = count;
		}
		
		if ( player_lv > 100 ) //LV上限設定 
		{
			player_lv = 100;
		}
		if ( player_exp > 999999 ) //LV上限設定 
		{
			player_exp = 999999;
		}

		// koizumi start
		//BGスクロール制御
		if (player_act == 1 )
		{
			bg_count++;
		}
		
		//エフェクト処理
		effect_move( );
		
		// koizumi end
			

		
	}
	
void level_up()					//LEVEL UP処理		
	{
		if ( ( player_exp >= player_lv*player_lv*10 ) && ( player_lv < 100 ) )
		{
			player_lv++;
			state_hp = state_hp + 10;
			Hell_playWAV( "lvup", 0, -1 );	
		}
	}
	
void player_status()			//LEVEL STATUS処理		
	{

		if ( state_atk <80 )	//MIN //性能補正 ATK DEF SPD
		{
			state_atk = 80;
		}
		if ( state_def <80 )
		{
			state_def = 80;
		}
		if ( state_spd <80 )
		{
			state_spd = 80;
		}
		if ( state_atk >125 )	//MAX
		{
			state_atk = 125;
		}
		if ( state_def >125 )
		{
			state_def = 125;
		}
		if ( state_spd >125 )
		{
			state_spd = 125;
		}
		
		if ( player_lv <=10 )	//lv10まではステータス影響が出ないようにする。
		{
			state_atk = 100;
			state_def = 100;
			state_spd = 100;
		}
		
		player_hp  = (player_lv + 4) * 10 ;
		player_atk = player_lv * 3 * state_atk /100 * ((state_hp *50/ player_hp) +50 + arms_atk) /100;
		player_def = player_lv * 3 * state_def /100 * ((state_hp *50/ player_hp) +50 + arms_def) /100;
		player_spd = player_lv * 3 * state_spd /100 * ((state_hp *50/ player_hp) +50 + arms_spd) /100;
		//HP減少でで50%の影響
		
		if (player_act == 1)		//探索
		{
			spd = ( 8 - (player_spd /80) );	//ステータスに依存
		}
		else if (player_act == 5)	//斬る
		{
			spd = ( 8 - (player_spd /60) );	//ステータスに依存
		}
		else if (player_act == 8)	//逃走
		{
			spd = 4;
		}
		else
		{
			spd = 15;
		}
	}
	
void arms_status()			//ARMS STATUS処理		
	{

			arms_type = (arms[arms_lock] /1000) % 100 -1;
			arms_atk = ((arms[arms_lock] /100) % 10 -3)*10;
			arms_def = ((arms[arms_lock] /10 ) % 10 -3)*10;
			arms_spd = ((arms[arms_lock] /1  ) % 10 -3)*10;
			
			
			
			if ( arms_atk >= (arms_atk + arms_def + arms_spd )/3 )
			{
				arms_r = 255;
			}
			else
			{
				arms_r = 0;
			}
			if ( arms_def >= (arms_atk + arms_def + arms_spd )/3 )
			{
				arms_b = 255;
			}
			else
			{
				arms_b = 0;
			}
			if ( arms_spd >= (arms_atk + arms_def + arms_spd )/3 )
			{
				arms_g = 255;
			}
			else
			{
				arms_g = 0;
			}
	}
	
void arms_drop()			//入手ARMS STATUS処理		
	{

	int drop;
	int drop_lv;
	int j;

		if ( player_lv > map[map_lock]*4 +1 )	//ドロップレベルレベルを調整。
		{
			drop_lv = (map[map_lock]*4 +1) +19;
		}
		else
		{
			drop_lv = (player_lv + 19 );
		}
			arms_type = Hell_randInt(1, 10)*1000;
			arms_atk = Hell_randInt(1, drop_lv/20 +5)*100;
			arms_def = Hell_randInt(1, drop_lv/20 +5)*10;
			arms_spd = Hell_randInt(1, drop_lv/20 +5)*1;
		
			drop = arms_type + arms_atk + arms_def + arms_spd;
		
		for ( j = 1 ; j <= 9 ; j++ )
		{
			if ( arms[j] == 0)
			{
				arms[j] = drop;
				j = 10;
				Hell_playWAV( "drop", 0, -1 );	
			}
		}
			
	}
void arms_absorb()			//吸収ARMS STATUS処理		
	{

		int a_bonus;
		
		arms_atk = ((arms[arms_lock] /100) % 10 );
		arms_def = ((arms[arms_lock] /10 ) % 10 );
		arms_spd = ((arms[arms_lock] /1  ) % 10 );

//		if ( arms_atk >arms_def )
//		{
//			a_bonus = arms_atk;
//		}
//		else if ( arms_def >arms_spd )
//		{
//			a_bonus = arms_def;
//		}
//		else
//		{
//			a_bonus = arms_spd;
//		}

		a_bonus = ( arms_atk + arms_def + arms_spd ) *10 / 3;
		
		player_act = 7;		//勝利状態
		Hell_playWAV( "absorb", 0, -1 );
		r_count = 240;
//		exp_bonus3 = ((player_lv * player_lv)-((player_lv-1)*(player_lv-1)))*a_bonus;
		exp_bonus3 = player_lv *a_bonus /10;
//		test = exp_bonus3;	//debug
		player_exp = player_exp + exp_bonus3;
		level_up();

		state_mp = state_mp + a_bonus*5;
		if ( state_mp >100)
		{
		state_mp = 100;
		}
		arms[10] = arms[arms_lock];
		absorb_count = 250;
		arms[arms_lock] = 0;
		arms_lock = 0;
		
		//整理
		arms_line();
	}

void arms_down()			//弱体化ARMS STATUS処理		
	{

		int arms_break = 0;
		
		arms_type =((arms[arms_lock] /1000) % 100 ) *1000;
		arms_atk = ((arms[arms_lock] /100) % 10 -Hell_randInt(0,2)) *100;
		arms_def = ((arms[arms_lock] /10 ) % 10 -Hell_randInt(0,2)) *10;
		arms_spd = ((arms[arms_lock] /1  ) % 10 -Hell_randInt(0,2)) *1;
			
		if ( arms_atk <= 0 )
		{
			arms_break = 1;
		}
		if ( arms_def <= 0 )
		{
			arms_break = 1;
		}
		if ( arms_spd <= 0 )
		{
			arms_break = 1;
		}
		
		if ( arms_break == 1 )
		{
			arms[arms_lock] = 0;//武器が壊れる
			arms_lock = 0;
			Hell_playWAV( "break2", 0, -1 );
		}
		else if ( arms[arms_lock] != arms_type + arms_atk + arms_def + arms_spd )
		{
			arms[arms_lock] = arms_type + arms_atk + arms_def + arms_spd;
			Hell_playWAV( "break1", 0, -1 );
		}
		//整理
		arms_line();
	}
	
void arms_line()			//整理ARMS STATUS処理		
	{

		int j;
		
		for ( roop_i = 0 ; roop_i <= 9 ; roop_i++ )	//武器整理
		{
			for ( j = 9 ; j >= 1 ; j-- )
			{
				if ( arms[j-1] == 0 )
				{
				arms[j-1] = arms[j];
				arms[j] = 0;
				}
			}
		}
			
	}
	
void enemy_status()			//ENEMY STATUS処理		
	{
		int plus;
		
		enemy_lv =  map[map_lock]*4 +1;
		enemy_hp  = (enemy_lv + 4) * 10 ;
		plus = ( ( map_lock + map[map_lock]) % 8) + 8;
		enemy_atk = (enemy_lv * plus * 3 /10);
		plus = ( ( map_lock * 2 + map[map_lock] * 3) % 8) + 8;
		enemy_def = (enemy_lv * plus * 3 /10);
		plus = ( ( map_lock * 3 + map[map_lock] * 2) % 8) + 8;
		enemy_spd = (enemy_lv * plus * 3 /10);
		enemy_type =( ( map_lock*3 + map[map_lock] ) % 12 );
		enemy_size = enemy_lv / 40 + 0.8;
		e_count = 300;		//ターゲットは攻撃に間を持たせる。
	}

void enemy_status2()			//ENEMY STATUS処理		
	{
		int plus;
		
		enemy_lv =  map[map_lock]*4 +1;
		target = 0;

		if ( ( (( Hell_randInt(0, enemy_lv ) <= 1 ) && (player_lv + 10 < enemy_lv ) )	//target
		     ||(( Hell_randInt(0, (enemy_lv / 5) + 5 ) == 0 ) && (player_lv + 10 >= enemy_lv )) )&& ( get[map_lock] == 0) )
		{
//		Hell_playWAV( "enemy2", 0, -1 );
		Hell_playBgm( "resource/sound/pp_battle02.ogg", -1, 0 );
		enemy_lv =  map[map_lock]*4 +1;
		enemy_hp  = (enemy_lv + 4) * 10 ;
		plus = ( ( map_lock + map[map_lock]) % 8) + 8;
		enemy_atk = (enemy_lv * plus * 3 /10);
		plus = ( ( map_lock * 2 + map[map_lock] * 3) % 8) + 8;
		enemy_def = (enemy_lv * plus * 3 /10);
		plus = ( ( map_lock * 3 + map[map_lock] * 2) % 8) + 8;
		enemy_spd = (enemy_lv * plus * 3 /10);
		enemy_type =( ( map_lock*3 + map[map_lock] ) % 12 );
		enemy_size = cast(float)(enemy_lv) / 40 +0.8 ;
		target = 1;
		e_count = 300;		//ターゲットは攻撃に間を持たせる。
		}
		else if ( Hell_randInt(0, 25 ) == 0 )	//レベル無視
		{
		enemy_lv =  Hell_randInt(1, 100 )+1;
		enemy_hp  = (enemy_lv + 4) * 10 ;
		plus = Hell_randInt(0, 5) + 8;
		enemy_atk = (enemy_lv * plus * 3 /10);
		plus = Hell_randInt(0, 5) + 8;
		enemy_def = (enemy_lv * plus * 3 /10);
		plus = Hell_randInt(0, 5) + 8;
		enemy_spd = (enemy_lv * plus * 3 /10);
		enemy_type = Hell_randInt(0, 12);
		enemy_size = cast(float)(enemy_lv) / 40 +0.8 ;
		target = 2;

			if ( enemy_lv >= map[map_lock]*4 +1 )
			{
			Hell_playWAV( "enemy3", 0, -1 );
			Hell_playBgm( "resource/sound/pp_battle03.ogg", -1, 0 );
			e_count = 300;		//強敵は攻撃に間を持たせる。
			}
			else
			{
//			Hell_playWAV( "enemy1", 0, -1 );
			Hell_playBgm( "resource/sound/pp_battle04.ogg", -1, 0 );
			e_count = 180;		//ザコは3秒。
			}
		}
		else 									//雑魚
		{
//		Hell_playWAV( "enemy1", 0, -1 );
		Hell_playBgm( "resource/sound/pp_battle01.ogg", -1, 0 );
		enemy_lv =  enemy_lv - Hell_randInt(0, 10);
			if(enemy_lv <= 0)
			{
				enemy_lv =1;
			}
		enemy_hp  = (enemy_lv + 4) * 10 ;
		plus = Hell_randInt(0, 3) + 8;
		enemy_atk = (enemy_lv * plus * 3 /10);
		plus = Hell_randInt(0, 3) + 8;
		enemy_def = (enemy_lv * plus * 3 /10);
		plus = Hell_randInt(0, 3) + 8;
		enemy_spd = (enemy_lv * plus * 3 /10);
		enemy_type = Hell_randInt(0, 12);
		enemy_size = cast(float)(enemy_lv) / 40 +0.8 ;
		e_count = 180;		//ザコは3秒。
		}
		
	}

void result_save()				//ゲームの記録		
	{
		if (count == 0)
		{		
//			Hell_playBgm( "resource/sound/results.ogg", 1, 0 );
			Hell_stopBgm( 30000 );
		}

			savedata.set("EXP", player_exp);
			savedata.set("LV", player_lv);
			savedata.set("HP",  state_hp);
			savedata.set("MP",  state_mp);
			savedata.set("ATK", state_atk);
			savedata.set("DEF", state_def);
			savedata.set("SPD", state_spd);
			savedata.set("T_SEARCH", t_search);
			savedata.set("T_BATTLE", t_battle);
		
			for ( roop_i = 0 ; roop_i <= 24 ; roop_i++ )	//マップ記録
			{
				str = std.string.format( "MAP%02d", roop_i );
				savedata.set( str , map[roop_i]);
				str = std.string.format( "GET%02d", roop_i );
				savedata.set( str , get[roop_i]);
			}
			for ( roop_i = 0 ; roop_i <= 9 ; roop_i++ )	//武器記録
			{
				str = std.string.format( "ARMS%02d", roop_i );
				savedata.set( str , arms[roop_i]);
			}

			savedata.write();

	}
	
	void draw()
	{
		int min;
		int sec;
		int msec;
		int chk;
		char[] str;
		
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
/*	
		Hell_drawTexture("title"
			, 0
			, 0
			, 0
			, 0
			, 640 , 480
			, 1.0 , 1.0
			, 0 );
*/

		Hell_drawRect( 1, 1,
				320 , 240,
				1, 0, 
				0, 0, 100, 
				255);							//window枠


		Hell_drawFont( "MIN SEC"  , 24,  5 , 1.5 , 255,255, 0);

		Hell_drawRect( 20 -2,  20 -2,
				2 +138 +2, 2 +18 +2,
				0, 0, 
				0, 100, 100, 
				255);						//TIMER SELECT誘導枠

		
		min = ( count / 60 ) / 60;
		sec = ( count / 60 ) % 60;
		msec = count % 60;
		str = std.string.format( "%02d", min );
		Hell_drawFont( str ,  20, 20 , 2.5 , 255,255,255);
		str = std.string.format( "%02d", sec );
		Hell_drawFont( str ,  70, 20 , 2.5 , 255,255,255);
		str = std.string.format( "%02d", msec );
		Hell_drawFont( str , 120, 20 , 2.5 , 200,200,200);
		Hell_drawFont( ":"  ,  54, 20 , 3 , 255,255,255);
		Hell_drawFont( ":"  , 104, 20 , 3 , 255,255,255);
		
		if ( ( ( Hell_getMouseX >20 ) && ( Hell_getMouseX <20+20 ) ) 
		   &&( ( Hell_getMouseY >20 ) && ( Hell_getMouseY <20+20 ) ) )
		{
			str = std.string.format( "%02d", min );
			Hell_drawFont( str ,  20, 20 , 2.5 , 100,255,100);
			Hell_SetGameflag( 10 , 6 );
			Hell_drawFont( "L +10min"  , 180, 20 , 1.5 , 255,255,255);
			Hell_drawFont( "R -10min"  , 180, 30 , 1.5 , 255,255,255);
		}
		else if ( ( ( Hell_getMouseX >40 ) && ( Hell_getMouseX <40+20 ) ) 
		   &&( ( Hell_getMouseY >20 ) && ( Hell_getMouseY <20+20 ) ) )
		{
			str = std.string.format( "%02d", min );
			Hell_drawFont( str ,  20, 20 , 2.5 , 100,255,100);
			Hell_SetGameflag( 10 , 1 );
			Hell_drawFont( "L  +1min"  , 180, 20 , 1.5 , 255,255,255);
			Hell_drawFont( "R  -1min"  , 180, 30 , 1.5 , 255,255,255);
		}		
		else if ( ( ( Hell_getMouseX >70 ) && ( Hell_getMouseX <70+20 ) ) 
		   &&( ( Hell_getMouseY >20 ) && ( Hell_getMouseY <20+20 ) ) )
		{
			str = std.string.format( "%02d", sec );
			Hell_drawFont( str ,  70, 20 , 2.5 , 100,255,100);
			Hell_SetGameflag( 10 , 7 );
			Hell_drawFont( "L +10sec"  , 180, 20 , 1.5 , 255,255,255);
			Hell_drawFont( "R -10sec"  , 180, 30 , 1.5 , 255,255,255);
		}
		else if ( ( ( Hell_getMouseX >90 ) && ( Hell_getMouseX <90+20 ) ) 
		   &&( ( Hell_getMouseY >20 ) && ( Hell_getMouseY <20+20 ) ) )
		{
			str = std.string.format( "%02d", sec );
			Hell_drawFont( str ,  70, 20 , 2.5 , 100,255,100);
			Hell_SetGameflag( 10 , 2 );
			Hell_drawFont( "L  +1sec"  , 180, 20 , 1.5 , 255,255,255);
			Hell_drawFont( "R  -1sec"  , 180, 30 , 1.5 , 255,255,255);
		}
		else if ( ( ( Hell_getMouseX >120 ) && ( Hell_getMouseX <120+40 ) ) 
		   &&( ( Hell_getMouseY >20 ) && ( Hell_getMouseY <20+20 ) ) )
		{
			str = std.string.format( "%02d", msec );
			Hell_drawFont( str ,  120, 20 , 2.5 , 100,255,100);
			Hell_SetGameflag( 10 , 3 );
			if ( lock == 0 )
			{
			Hell_drawFont( "L START"  , 180, 20 , 1.5 , 100,255,100);
			}
			else
			{
			Hell_drawFont( "L STOP"  , 180, 20 , 1.5 , 100,255,100);
			}
			Hell_drawFont( "R RESET"  	   , 180, 30 , 1.5 , 255,100,100);
		}
		else if ( ( ( Hell_getMouseX >110 +0 ) && ( Hell_getMouseX <110+ 80 ) ) //comand1 YELL
		   &&( ( Hell_getMouseY >180 ) && ( Hell_getMouseY < 180 +16 ) ) && (exp_timer > 0) && ( lock == 1 ) )
		{
			Hell_SetGameflag( 10 , 12 );
			Hell_drawRect( 110 ,180 + 16*0
				          , 80 , 16, 1, 0, 	255, 255, 0, 255);	//カーソル
		}
		else if ( ( ( Hell_getMouseX >110 +0 ) && ( Hell_getMouseX <110+ 80 ) ) //comand2
		   &&( ( Hell_getMouseY >180+16 ) && ( Hell_getMouseY < 180 +32 ) ) && (exp_timer > 0) && ( lock == 1 ) )
		{
			Hell_SetGameflag( 10 , 13 );
			Hell_drawRect( 110 ,180 + 16*1
				          , 80 , 16, 1, 0, 	255, 255, 0, 255);	//カーソル
		}
		else if ( ( ( Hell_getMouseX >400 ) && ( Hell_getMouseX <400+40 ) ) //debug1
		   &&( ( Hell_getMouseY > 50 ) && ( Hell_getMouseY < 50+20 ) ) )
		{
			Hell_drawFont( "25" ,  400, 50 , 2.5 , 100,255,100);
			Hell_SetGameflag( 10 , 25 );
			Hell_drawFont( "L -----"  , 450,  50 , 1.5 , 100,255,100);
			Hell_drawFont( "R EXP +1min"  , 450,  70 , 1.5 , 255,100,100);
		}
		else if ( ( ( Hell_getMouseX >400 ) && ( Hell_getMouseX <400+40 ) ) //debug2
		   &&( ( Hell_getMouseY > 70 ) && ( Hell_getMouseY < 70+20 ) ) )
		{
			Hell_drawFont( "26" ,  400, 70 , 2.5 , 100,255,100);
			Hell_SetGameflag( 10 , 26 );
			Hell_drawFont( "L BATTLE"  , 450,  70 , 1.5 , 100,255,100);
			Hell_drawFont( "R CHANGE"  , 450,  90 , 1.5 , 255,100,100);
		}
		else if ( ( ( Hell_getMouseX >400 ) && ( Hell_getMouseX <400+40 ) ) //debug3
		   &&( ( Hell_getMouseY > 90 ) && ( Hell_getMouseY < 90+20 ) ) )
		{
			Hell_drawFont( "27" ,  400, 90 , 2.5 , 100,255,100);
			Hell_SetGameflag( 10 , 27 );
			Hell_drawFont( "L DROP"  , 450,  70 , 1.5 , 100,255,100);
			Hell_drawFont( "R ON/OFF"  , 450,  90 , 1.5 , 255,100,100);
		}
		else if ( ( ( Hell_getMouseX >400 ) && ( Hell_getMouseX <400+40 ) ) //debug4
		   &&( ( Hell_getMouseY > 90 ) && ( Hell_getMouseY < 110+20 ) ) )
		{
			Hell_drawFont( "28" ,  400, 110 , 2.5 , 100,255,100);
			Hell_SetGameflag( 10 , 28 );
			Hell_drawFont( "HP +10"  , 450,  70 , 1.5 , 100,255,100);
			Hell_drawFont( "HP -10"  , 450,  90 , 1.5 , 255,100,100);
		}
		else
		{
			Hell_SetGameflag( 10 , 10 );
		}
		
		if ( player_act <=3 )
		{
		status_draw();	//通常時のステータス表示
		}
		else
		{
		battle_draw();	//戦闘時のステータス表示
		}
		
		//koizumi start
		//エフェクト処理をここに入れてみる
		effect_draw( );
		//koizumi end

		
		if ( ( exp_timer == 0 ) 
		&& ( Hell_getMouseX > map_l -5) && ( Hell_getMouseX < map_l +100 +5) 
		&& ( Hell_getMouseY > 80 -20 ) && ( Hell_getMouseY <180 +20) )
		{
			map_draw( map_l,  80, map_x, map_y);			//MAP表示	
		}
		
		if ( ( exp_timer == 0 ) && ( text_p == 0 )
		&& ( Hell_getMouseX > 200 -5) && ( Hell_getMouseX < 200 +100 +5) 
		&& ( Hell_getMouseY > 80 -20 ) && ( Hell_getMouseY <180 +20) )
		{
			Hell_SetGameflag( 10 , 16 );
			text_draw( 160,  80);							//TEXT menu表示	
		}
		if ( ( exp_timer == 0 ) && ( text_p != 0 )
		&& ( Hell_getMouseX > 160 -5) && ( Hell_getMouseX < 160 +140 +5) 
		&& ( Hell_getMouseY > 80 -20 ) && ( Hell_getMouseY <180 +20) )
		{
			Hell_SetGameflag( 10 , 17 );
			text_draw( 160,  80);							//TEXT表示	
		}
		
			//DEBUG STATUS
			str = std.string.format( "%02d", Hell_GetGameflag(10) );				
			Hell_drawFont( str , 300, 300 , 3 , 255,255,255);	//flag
			str = std.string.format( "%02d", map_lock );				
			Hell_drawFont( str , 350, 300 , 3 , 255,255,255);	//map_lock
			str = std.string.format( "%02d", player_act );				
			Hell_drawFont( str , 300, 400 , 3 , 255,255,255);	//player_act
			str = std.string.format( "%05d", test );				
			Hell_drawFont( str , 300, 420 , 3 , 255,255,255);	//test
			str = std.string.format( "%03d", b_count );				
			Hell_drawFont( str , 410, 300 , 3 , 255,255,255);	//b_count
			str = std.string.format( "%03d", e_count );				
			Hell_drawFont( str , 410, 320 , 3 , 255,255,255);	//e_count
			//ステータス表示
			Hell_drawFont( "PASS"  , 180, 250 , 2 , 255,255,255);
			min = ( exp_timer / 60 ) / 60;
			sec = ( exp_timer / 60 ) % 60;
			msec = exp_timer % 60;
			str = std.string.format( "%02d", min );				//経過タイム
			Hell_drawFont( str ,  20, 250 , 2.5 , 100,100,255);
			str = std.string.format( "%02d", sec );
			Hell_drawFont( str ,  70, 250 , 2.5 , 100,100,255);
			str = std.string.format( "%02d", msec );
			Hell_drawFont( str , 120, 250 , 2.5 , 100,100,255);
			Hell_drawFont( ":"  ,  54, 250 , 3 , 100,100,255);
			Hell_drawFont( ":"  , 104, 250 , 3 , 100,100,255);
			//ステータス表示
			Hell_drawFont( "MAX"  , 180, 270 , 2 , 255,255,255);
			min = ( count_max / 60 ) / 60;
			sec = ( count_max / 60 ) % 60;
			msec = count_max % 60;
			str = std.string.format( "%02d", min );				//MAXタイム
			Hell_drawFont( str ,  20, 270 , 2.5 , 100,100,255);
			str = std.string.format( "%02d", sec );
			Hell_drawFont( str ,  70, 270 , 2.5 , 100,100,255);
			str = std.string.format( "%02d", msec );
			Hell_drawFont( str , 120, 270 , 2.5 , 100,100,255);
			Hell_drawFont( ":"  ,  54, 270 , 3 , 100,100,255);
			Hell_drawFont( ":"  , 104, 270 , 3 , 100,100,255);
			//ステータス表示
			Hell_drawFont( "NEXT EXP"  , 180, 290 , 2 , 255,255,255);
			str = std.string.format( "%06d", player_lv*player_lv*10 );
			Hell_drawFont( str , 20, 290 , 2.5 , 100,100,255);
			Hell_drawFont( "BONUS"  ,  20, 310 , 2 , 100,100,255);
			str = std.string.format( "%04d", exp_bonus );				
			Hell_drawFont( str ,  110, 310 , 2 , 100,100,255);
			str = std.string.format( "%04d", timer );				
			Hell_drawFont( str ,  110, 330 , 2 , 100,100,255);
		
		if ( absorb_count > 0 )		//武器吸収エフェクト
		{
			absorb_draw();
			absorb_count = absorb_count - 3;
		}

//		Hell_drawFont("ALPHA SECRET BASE 2011" , 280, 480-20 , 2 , 255,255,255);
	}
	
	void status_draw()
	{
		int chk;
		char[] str;

		// koizumi start
		//BGの表示２画面プールに対応させる
		int speed = ( bg_count * 2 ) % 512;
	
		char[] bgstr = format("bg01"); 
		switch( bg_type )
		{
		case 0:
		default:
			bgstr = format("bg01"); 
			break;
		case 1:
			bgstr = format("bg02"); 
			break;
		case 2:
			bgstr = format("bg03"); 
			break;
		case 3:
			bgstr = format("bg04"); 
			break;
		case 4:
			bgstr = format("bg05"); 
			break;
		}
		Hell_drawTexture(bgstr			//BG表示
			, 0 - speed 
			, 50
			, 64
			, 112
			, 512, 128
			, 1 , 1
			, 0
			,255, 255, 255, 255 );
			
		Hell_drawTexture(bgstr			//BG表示
			, 0 - speed + 512 
			, 50
			, 64
			, 112
			, 512, 128
			, 1 , 1
			, 0
			,255, 255, 255, 255 );
		// koizumi end
		
		if ( Hell_GetGameflag(10) >= 10 )
		{

			//AREA表示
			map_draw2( 200, 20);
		}

		player_draw( 110 +50 ,80 +50 , 1 , timer );		//主人公 表示

		//主人公ステータス表示
		Hell_drawFont( "LV "  ,  20, 45 , 2 , 200,200,255);
		str = std.string.format( "%02d", player_lv );				
		Hell_drawFont( str ,  60, 45 , 2 , 200,200,255);
		//status 
		chk = cast(int)(state_hp*100/player_hp*.8+1);
		if ( chk < 1 )
		{
			chk = 1;
		}

		Hell_drawFont( "HP "  ,  20, 70 , 1.5 ,200,200,255);
		str = std.string.format( "%04d", state_hp );				
		Hell_drawFont( str ,  50, 70 , 1.5 , 200,200,255);
		Hell_drawRect( 20, 70 +5 , chk , 8, 0, 0, 	255, 0, 0, 100);	//HP

		chk = cast(int)(state_mp*.8);
		if ( chk < 1 )
		{
			chk = 1;
		}

		Hell_drawFont( "MP "  ,  20, 90 , 1.5 , 200,200,255);
		str = std.string.format( "%03d", state_mp );				
		Hell_drawFont( str ,  60, 90 , 1.5 , 200,200,255);
		Hell_drawRect( 20, 90 +5 , chk , 8, 0, 0, 	0, 127, 255, 100);	//MP


		Hell_drawFont( "ATK"  ,  20, 110 , 1.5 , 200,200,255);
		str = std.string.format( "%03d", player_atk );				
		Hell_drawFont( str ,  60, 110 , 1.5 , 200,200,255);
		Hell_drawRect( 20, 110 +5 , cast(int)(state_atk*.5 * ((state_hp *50/ player_hp) + 50+arms_atk) / 100) , 8, 0, 0, 	255, 100, 100, 100);	//ATK

		Hell_drawFont( "DEF"  ,  20, 130 , 1.5 , 200,200,255);
		str = std.string.format( "%03d", player_def );				
		Hell_drawFont( str ,  60, 130 , 1.5 , 200,200,255);
		Hell_drawRect( 20, 130 +5 , cast(int)(state_def*.5 * ((state_hp *50/ player_hp) + 50+arms_def) / 100) , 8, 0, 0, 	100, 255, 255, 100);	//DEF

		Hell_drawFont( "SPD"  ,  20, 150 , 1.5 , 200,200,255);
		str = std.string.format( "%03d", player_spd );				
		Hell_drawFont( str ,  60, 150 , 1.5 , 200,200,255);
		Hell_drawRect( 20, 150 +5 , cast(int)(state_spd*.5 * ((state_hp *50/ player_hp) + 50+arms_spd) / 100) , 8, 0, 0, 	100, 255, 100, 100);	//SPD

		Hell_drawFont( "EXP"  ,  20, 170 , 1.5 , 200,200,255);
		str = std.string.format( "%06d", player_exp );				
		Hell_drawFont( str ,  24, 185 , 1.5 , 200,200,255);
		Hell_drawRect( 20, 185 +5 , 80 , 8, 0, 0, 	0, 0, 255, 100);	//EXP枠
		if ( ( cast(int)( (( player_exp  - ( (player_lv - 1) * (player_lv - 1)*10 ) )*80 ) 
		/ (( player_lv*player_lv*10 )  - ( (player_lv - 1) * (player_lv - 1)*10 )) ) > 0) && ( player_lv < 100) )
		{
			Hell_drawRect( 20, 185 +5 , cast(int)( ( ( player_exp  - ( (player_lv - 1) * (player_lv - 1)*10 ) ) * 80 ) 
			/ (( player_lv*player_lv*10 ) - ( (player_lv - 1) * (player_lv - 1)*10 )) ) , 8, 0, 0, 	255, 255,  0, 100);	//EXP
		}

		arms_draw(20,220);	//選択武器の表示

		if ( ( lock == 1 ) && ( Hell_GetGameflag(10) != 15 ) )
		{

		Hell_drawTexture("player"			//COMMAND表示
			, 160 - 50
			, 130 + 50
			, 320 
			, 64
			, 80, 16 *2
			, 1 , 1
			, 0
			,255, 255, 255, 255 );
		}
	}
	
	void battle_draw()
	{
		int chk;
		char[] str;

		// koizumi start
		//BGの表示２画面プールに対応させる
		int speed = ( bg_count * 2 ) % 512;
	
		char[] bgstr = format("bg01"); 
		switch( bg_type )
		{
		case 0:
		default:
			bgstr = format("bg01"); 
			break;
		case 1:
			bgstr = format("bg02"); 
			break;
		case 2:
			bgstr = format("bg03"); 
			break;
		case 3:
			bgstr = format("bg04"); 
			break;
		case 4:
			bgstr = format("bg05"); 
			break;
		}
		Hell_drawTexture(bgstr			//BG表示
			, 0 - speed 
			, 50
			, 64
			, 112
			, 512, 128
			, 1 , 1
			, 0
			,255, 255, 255, 255 );
			
		Hell_drawTexture(bgstr			//BG表示
			, 0 - speed + 512 
			, 50
			, 64
			, 112
			, 512, 128
			, 1 , 1
			, 0
			,255, 255, 255, 255 );
		// koizumi end

		player_draw( 60 +50 ,80 +50 , 1 , timer );		//主人公 表示

		//主人公ステータス表示
		Hell_drawFont( "LV "  ,  20, 45 , 2 , 200,200,255);
		str = std.string.format( "%02d", player_lv );				
		Hell_drawFont( str ,  60, 45 , 2 , 200,200,255);
		//status 
		chk = cast(int)(state_hp*100/player_hp*.8+1);
		if ( chk < 1 )
		{
			chk = 1;
		}

		Hell_drawFont( "HP "  ,  20, 150 , 1.0 ,200,200,255);
		str = std.string.format( "%04d", state_hp );				
		Hell_drawFont( str ,  52, 150 , 1.0 , 200,200,255);
		Hell_drawRect( 20, 150 +5 , chk , 5, 0, 0, 	255, 0, 0, 100);	//HP

		chk = cast(int)(state_mp*.8);
		if ( chk < 1 )
		{
			chk = 1;
		}

		Hell_drawFont( "MP "  ,  20, 160 , 1.0 , 200,200,255);
		str = std.string.format( "%03d", state_mp );				
		Hell_drawFont( str ,  60, 160 , 1.0 , 200,200,255);
		Hell_drawRect( 20, 160 +5 , chk , 5, 0, 0, 	0, 127, 255, 100);	//MP


		Hell_drawFont( "ATK"  ,  20, 180 , 1.0 , 200,200,255);
		str = std.string.format( "%03d", player_atk );				
		Hell_drawFont( str ,  60, 180 , 1.0 , 200,200,255);
		Hell_drawRect( 20, 180 +5 , cast(int)(state_atk*.5 * ((state_hp *50/ player_hp) + 50+arms_atk) / 100) , 5, 0, 0, 	255, 100, 100, 100);	//ATK

		Hell_drawFont( "DEF"  ,  20, 190 , 1.0 , 200,200,255);
		str = std.string.format( "%03d", player_def );				
		Hell_drawFont( str ,  60, 190 , 1.0 , 200,200,255);
		Hell_drawRect( 20, 190 +5 , cast(int)(state_def*.5 * ((state_hp *50/ player_hp) + 50+arms_def) / 100) , 5, 0, 0, 	100, 255, 255, 100);	//DEF

		Hell_drawFont( "SPD"  ,  20, 200 , 1.0 , 200,200,255);
		str = std.string.format( "%03d", player_spd );				
		Hell_drawFont( str ,  60, 200 , 1.0 , 200,200,255);
		Hell_drawRect( 20, 200 +5 , cast(int)(state_spd*.5 * ((state_hp *50/ player_hp) + 50+arms_spd) / 100) , 5, 0, 0, 	100, 255, 100, 100);	//SPD


		enemy_draw( 200, 80+50 ,enemy_size);		//敵 表示

		//敵ステータス表示
		Hell_drawFont( "LV "  ,  225, 45 , 2 , 200,200,255);
		str = std.string.format( "%02d", enemy_lv );				
		Hell_drawFont( str ,  260, 45 , 2 , 200,200,255);
		//status 
		chk = cast(int)(enemy_hp*100/player_hp*.8+1);
		if ( chk < 1 )
		{
			chk = 1;
		}
		else if (chk >100)
		{
			chk= 100 ;
		}

		Hell_drawFont( "HP "  ,  220, 150 , 1.0 ,200,200,255);
		if (chk < 100)
		{
		Hell_drawRect( 220, 150 +5 , chk , 5, 0, 0, 	255, 0, 0, 100);	//HP
		str = std.string.format( "%04d", enemy_hp );				
		Hell_drawFont( str ,  255, 150 , 1.0 , 200,200,255);
		}
		else
		{
			Hell_drawRect( 220, 150 +5 , chk , 5, 0, 0, 	255, 100, 100, 200);	//HP
			Hell_drawFont( "TOUGHNESS"  ,  220 +10, 150 +5, 1.0 , 255, 0, 0);
		}
		Hell_drawFont( "ATK"  ,  220, 180 , 1.0 , 200,200,255);
		chk = cast(int)( (enemy_atk*100 / (player_lv*3) ) *.5 );
		if ( chk < 1 )
		{
			chk = 1;
		}
		if (enemy_atk <= player_lv*6)
		{
		Hell_drawRect( 220, 180 +5 , chk , 5, 0, 0, 	255, 100, 100, 100);	//ATK

		str = std.string.format( "%03d", enemy_atk );				
		Hell_drawFont( str ,  260, 180 , 1.0 , 200,200,255);
		}
		else
		{
			Hell_drawRect( 220, 180 +5 , 100 , 5, 0, 0, 	255, 100, 100, 200);	//WARNING

			Hell_drawFont( "WARNING"  ,  220 +20, 180 +5, 1.0 , 255, 0, 0);
		}
		Hell_drawFont( "DEF"  ,  220, 190 , 1.0 , 200,200,255);
		chk = cast(int)( (enemy_def*100 / (player_lv*3) ) *.5 );
		if ( chk < 1 )
		{
			chk = 1;
		}
		if (enemy_def <= player_lv*6)
		{
		Hell_drawRect( 220, 190 +5 , chk , 5, 0, 0, 	100, 255, 255, 100);	//DEF

		str = std.string.format( "%03d", enemy_def );				
		Hell_drawFont( str ,  260, 190 , 1.0 , 200,200,255);
		}
		else
		{
			Hell_drawRect( 220, 190 +5 , 100 , 5, 0, 0, 	255, 100, 100, 200);	//WARNING

			Hell_drawFont( "WARNING"  ,  220 +20, 190 +5, 1.0 , 255, 0, 0);
		}
		Hell_drawFont( "SPD"  ,  220, 200 , 1.0 , 200,200,255);
		chk = cast(int)( (enemy_spd*100 / (player_lv*3) ) *.5 );
		if ( chk < 1 )
		{
			chk = 1;
		}
		if (enemy_spd <= player_lv*6)
		{
		Hell_drawRect( 220, 200 +5 , chk , 5, 0, 0, 	100, 255, 100, 100);	//SPD

		str = std.string.format( "%03d", enemy_spd );				
		Hell_drawFont( str ,  260, 200 , 1.0 , 200,200,255);
		}
		else
		{
			Hell_drawRect( 220, 200 +5 , 100 , 5, 0, 0, 	255, 100, 100, 200);	//WARNING

			Hell_drawFont( "WARNING"  ,  220 + 20, 200 +5 , 1.0 , 255, 0, 0);
		}

		arms_draw(20,220);	//選択武器の表示

		if ( ( lock == 1 ) && ( Hell_GetGameflag(10) !=15 ) )
		{

		Hell_drawTexture("player"			//COMMAND表示
			, 160 - 50
			, 130 + 50
			, 320 
			,  96
			, 80, 16 *2
			, 1 , 1
			, 0
			,255, 255, 255, 255 );
		}

		if ( ( r_count >0 )&&( player_act ==4) )
		{
		Hell_drawFont( "BATTLE"  ,  100, 100 , 3 , 255, 0, 0);
		}

		if ( target == 1 )				//鎮圧完了
		{
			Hell_drawFont( "TARGET"  ,  180 + Hell_randInt(0,2)*4 , 20 + Hell_randInt(0,2)*4 , 2.5 
				, 100 + Hell_randInt(0,2)*155 ,100 + Hell_randInt(0,2)*155 ,100);
		}

		
		//debug disp
		str = std.string.format( "%04d", enemy_hp );				
		Hell_drawFont( str ,  355, 160 , 1.0 , 200,200,255);
		str = std.string.format( "%03d", enemy_atk );				
		Hell_drawFont( str ,  360, 180 , 1.0 , 200,200,255);
		str = std.string.format( "%03d", enemy_def );				
		Hell_drawFont( str ,  360, 190 , 1.0 , 200,200,255);
		str = std.string.format( "%03d", enemy_spd );				
		Hell_drawFont( str ,  360, 200 , 1.0 , 200,200,255);
	}
	
/* effect    ********************************************************************/
/*	アニメ関連																	*/
/********************************************************************************/

	void player_draw( float px , float py ,float size ,int c )		//主人公表示
	{
		int j;
		int k;
		int bx;
		int by;
		int br;

		if ( ( player_act != 2 ) && ( player_act != 6 ) )
		{
			star_draw(px,py, cast(int)((state_hp*40/player_hp)*size) , count);	//回転する星 表示
		}

		if ( ( player_act ==4 ) && ( (c % (spd * 8) ) / spd <4 ) )		//武器表示 待機
		{
			bx = 20;	by = -8;	br = 0;
		}
		else if ( ( player_act ==4 ) && ( (c % (spd * 8) ) / spd >=4 ) )
		{
			bx = 20;	by = -7;	br = 0;
		}
		
		
		if ( player_act == 4 ) 
		{
		Hell_drawTexture("player"		//武器表示 back
			, px - ( size * 32 / 2) 					+ bx
			, py - ( size * 32 / 2) - size * 16 + 16	+ by
			, 32 * arms_type 
			, 32 * 14
			, 32 , 32
			, size, size
			, br
			,arms_r, arms_g, arms_b, 255 );
		}
		
		if ( atk_count == 0 )
		{
		Hell_drawTexture("player"		//player表示 通常
			, px - ( size * 32 / 2) 
			, py - ( size * 32 / 2) - size * 16 + 16
			, 32 *( (c % (spd * 8) ) / spd ) 
			, 32 * player_act
			, 32 , 32
			, size, size
			, 0
			,255, 255, 255, 255 );
		}
		else
		{
//			px = px + ( 24 - atk_count) * 2;
			k = ( 24-atk_count) / 3 ;

			if ( ( ( k == 1 ) || ( k == 5 ) ) && ( ( 24-atk_count) % 3 == 0 ) ) //攻撃音
			{
				Hell_playWAV( "atk1", 0, -1 );	
				
				//koizumi start
				//ヒットエフェクトの追加
				int ei = 0;
				float dir1 = cast( float )Hell_randInt(0, 360 );
				float dir2 = cast( float )Hell_randInt(0, 360 );
				for ( ei = 0; ei < 8; ei++ )
				{
					float pos_x = 172.0;
					float pos_y = 130.0;
					float spd = cast( float )(ei *  0.8f);
					create_effect( 0, pos_x, pos_y, dir1, spd, 128, 128, 255 );
					create_effect( 0, pos_x, pos_y, dir1 + 180, spd, 128, 128, 255 );
					create_effect( 0, pos_x, pos_y, dir2, spd, 128, 128, 255 );
					create_effect( 0, pos_x, pos_y, dir2 + 180, spd, 128, 128, 255 );
				}
				//koizumi start
			}

			if ( ( player_act ==5 ) && ( k == 0 ) )	//武器表示
			{
				bx = -17;	by = -16;	br = 130;
			}
			else if ( ( player_act ==5 ) && ( k == 1 ) )
			{
				bx = 12;	by = -22;	br = 45;
			}
			else if ( ( player_act ==5 ) && ( k == 2 ) )
			{
				bx = 20;	by = -7;	br = 0;
			}
			else if ( ( player_act ==5 ) && ( k == 3 ) )
			{
				bx = 22;	by =  10;	br = 305;
			}
			else if ( ( player_act ==5 ) && ( k == 4 ) )
			{
				bx = -17;	by = -16;	br = 130;
			}
			else if ( ( player_act ==5 ) && ( k == 5 ) )
			{
				bx = 12;	by = -22;	br = 45;
			}
			else if ( ( player_act ==5 ) && ( k == 6 ) )
			{
				bx = 20;	by = -7;	br = 0;
			}
			else if ( ( player_act ==5 ) && ( k == 7 ) )
			{
				bx = 22;	by =  10;	br = 305;
			}
		Hell_drawTexture("player"		//武器表示 back
			, px - ( size * 32 / 2) 					+ bx
			, py - ( size * 32 / 2) - size * 16 + 16	+ by
			, 32 * arms_type 
			, 32 * 14
			, 32 , 32
			, size, size
			, br
			,arms_r, arms_g, arms_b, 255 );
		Hell_drawTexture("player"			//player 表示 攻撃
			, px - ( size * 32 / 2) 
			, py - ( size * 32 / 2) - size * 16 + 16
			, 32 * k 
			, 32 * player_act
			, 32 , 32
			, size, size
			, 0
			,255, 255, 255, 255 );
		}
		
		
		if (exp_timer == 0)
		{
		Hell_drawRect( map_l -5,  80 -20,
				5 +100 +5, 20+ 100 +20,
				0, 0, 
				0, 100, 100, 
				200);						//AREA SELECT誘導枠

		Hell_drawRect( 200 -5,  80 -20,
				5 +100 +5, 20+ 100 +20,
				0, 0, 
				0, 100, 100, 
				200);						//TEXT SELECT誘導枠

		}
		else
		{						
			
			if ( player_act == 2 ) 	//player 状態
			{
				Hell_drawFont( "TIRED"  , cast(int)px -50, cast(int)py +35 , 1.5 ,	 255,0,0);
			}
			else if ( player_act == 1 )
			{
				Hell_drawFont( "SEARCH"  , cast(int)px -50, cast(int)py +35 , 1.5 ,	 0,0,255);
			}
			else if ( player_act == 3 )
			{
				Hell_drawFont( "REST"  , cast(int)px -50, cast(int)py +35 , 1.5 ,	 0,255,0);
			}
		}
	}


	void enemy_draw( float sx , float sy , float size)		//敵 表示
	{
		int l;
		int enemy_r;
		int enemy_b;
		int enemy_g;
		int enemy_a;
		char[] str;

		if ( enemy_atk >= (enemy_atk + enemy_def + enemy_spd )/3 )
		{
			enemy_r = 255;
		}
		else
		{
			enemy_r = 0;
		}
		if ( enemy_def >= (enemy_atk + enemy_def + enemy_spd )/3 )
		{
			enemy_b = 255;
		}
		else
		{
			enemy_b = 0;
		}
		if ( enemy_spd >= (enemy_atk + enemy_def + enemy_spd )/3 )
		{
			enemy_g = 255;
		}
		else
		{
			enemy_g = 0;
		}
		
		if ( ( eatk_count > 16 ) && ( eatk_count <= 24 ) )
		{
		sx = sx  -( 24 - eatk_count ) *6 ;
		}
		if ( ( eatk_count > 0 ) && ( eatk_count <= 16 ) )
		{
		sx = sx  -( eatk_count ) *3 ;
		}
		
		if ( eatk_count == 16 ) //攻撃音
		{
		Hell_playWAV( "atk2", 0, -1 );	
		}
		
			enemy_a = 255;
			if ( enemy_hp<=0 )
			{
				enemy_a= r_count;
				
			}
		
			for ( l = 0 ; l <= 3 ; l++ )
			{
			Hell_drawTexture("enemy"			//敵表示 波
				, sx - ( size * 32 / 2) + l*8*size + size * 16 -16  
				, sy - ( size * 32 / 2) + (((timer + l*10)/30) % 2) -1  - size * 16 + 16
				, 32 * enemy_type + l*8
				, 32 * 2
				, 8 , 32
				, size, size
				, 0
				,enemy_r, enemy_g, enemy_b, enemy_a );
			}

			if ( enemy_hp<=0 )
			{
				str = std.string.format( "EXP +%02d", exp_bonus3);
				Hell_drawFont( str , 100 , 100+(r_count/30) , 1.5 , 0, 255, 0);	
				
			}
	}
	void star_draw( float sx , float sy ,int size , int deg_c )		//回転する星
	{
		int j;
		int ring = 5;
		int deg_loop = ( deg_c * 6) ;
		int deg_sec = ( deg_c / 60) % 60 * ( 360 / 60) ;
		int deg_x   = ( deg_c / 360) ;
		int deg_y   = ( deg_c / 30)*2 ;

		
		for ( j = 0 ; j <= ring ; j++ )
		{
		Hell_drawTexture("player"
			, sx + ( Hell_cosEx( j * ( 360 / ring ) + deg_loop + deg_sec - 90 + deg_x ) ) * size - 8 * 0.3
			, sy + ( Hell_sinEx( j * ( 360 / ring ) + deg_loop + deg_sec - 90 + deg_y ) ) * size - 8 * 0.3
			, 320 
			, 32
			, 16, 16
			, 0.5 , 0.5
			, 0
			,64, 64, 64, 128 );
			
		Hell_drawTexture("player"
			, sx + ( Hell_cosEx( j * ( 360 / ring ) + deg_loop + deg_sec - 90 + deg_x ) ) * size - 8 * 0.3
			, sy + ( Hell_sinEx( j * ( 360 / ring ) + deg_loop + deg_sec - 90 + deg_y ) ) * size - 8 * 0.3
			, 320 
			, 32
			, 16, 16
			, 0.3 , 0.3
			, 0
			,255, 255, 255, 255 );
		}
		if ( ( deg_c % 60 ) <= 10 )
		{
		Hell_drawTexture("player"
			, sx + ( Hell_cosEx( deg_loop + deg_sec - 90 + deg_x ) ) * size - 8 * 0.7
			, sy + ( Hell_sinEx( deg_loop + deg_sec - 90 + deg_y ) ) * size - 8 * 0.7
			, 320 
			, 32
			, 16, 16
			, 0.9 , 0.9
			, 0
			,64, 64, 64, 255 );
			
		Hell_drawTexture("player"
			, sx + ( Hell_cosEx( deg_loop + deg_sec - 90 + deg_x ) ) * size - 8 * 0.7
			, sy + ( Hell_sinEx( deg_loop + deg_sec - 90 + deg_y ) ) * size - 8 * 0.7
			, 320 
			, 32
			, 16, 16
			, 0.7 , 0.7
			, 0
			,255, 255, 255, 255 );
		}
		else
		{
		Hell_drawTexture("player"
			, sx + ( Hell_cosEx( deg_loop + deg_sec - 90 + deg_x ) ) * size - 8 * 0.5
			, sy + ( Hell_sinEx( deg_loop + deg_sec - 90 + deg_y ) ) * size - 8 * 0.5
			, 320 
			, 32
			, 16, 16
			, 0.7 , 0.7
			, 0
			,64, 64, 64, 255 );

		Hell_drawTexture("player"
			, sx + ( Hell_cosEx( deg_loop + deg_sec - 90 + deg_x ) ) * size - 8 * 0.5
			, sy + ( Hell_sinEx( deg_loop + deg_sec - 90 + deg_y ) ) * size - 8 * 0.5
			, 320 
			, 32
			, 16, 16
			, 0.5 , 0.5
			, 0
			,255, 255, 255, 255 );
		}
	}




	void map_draw( int sx , int sy ,int x, int y) 		//MAP SELECT
	{
		int j;
		int k;
		char[] str;

		Hell_drawRect( sx -5,  80 -20,
				5 +100 +5, 20+ 100 +20,
				0, 0, 
				0, 100, 100, 
				200);						//AREA SELECT誘導枠

		Hell_drawFont( "AREA MAP"  , sx +2, sy-15 , 1.5 ,	 255,0,0);
		
		for ( j = 0 ; j <= 24 ; j++ )
		{
			k = map[j];//敵レベル設定
			Hell_drawRect( sx + (j % 5) *20 , sy + (j /5) *20
				, 19 , 19, 0, 0, 	cast(int)(k*10+0), 255*get[j], 155-k*5, 200);	//MAP枠
		}
			Hell_drawRect( sx + (map_lock % 5) * 20 , sy + (map_lock / 5) *20
				, 19 , 19, 1, 0, 	255, 255, 255, 255);		//MAP_lock枠
		if ( ( sx < Hell_getMouseX ) && ( sx +100 > Hell_getMouseX ) 
		 &&  ( sy < Hell_getMouseY ) && ( sy +100 > Hell_getMouseY ) )
		{
			Hell_drawRect( Hell_getMouseX - ( ( Hell_getMouseX + sx )% 20) ,Hell_getMouseY / 20 * 20
				          , 19 , 19, 1, 0, 	255, 255, 0, 255);	//MAPカーソル
			Hell_SetGameflag( 10 , 11 );
			
			j = (Hell_getMouseX - ( ( Hell_getMouseX + sx )% 20) -sx )/20 
			  + (Hell_getMouseY / 20 * 20 -sy )/20 * 5 ;
			str = std.string.format( "%02d", map[j]*4+1 );
			Hell_drawFont( str , sx + (j % 5) *20+2 , sy + (j /5) *20+5 , 1.0 , 255,255,255);	//x

			str = std.string.format( "%02d", x / 20 );
			Hell_drawFont( str , 300, 340 , 2 , 255,255,255);	//x
			str = std.string.format( "%02d", y / 20 );
			Hell_drawFont( str , 260, 340 , 2 , 255,255,255);	//y
			str = std.string.format( "%02d", map[(y / 20)*5+(x / 20)] );
			Hell_drawFont( str , 300, 360 , 2 , 255,255,255);	//
			
		}
		
	}


	void map_draw2( int sx , int sy) 		//SELECT ACT
	{
		int j;
		int k;
		int l;
		int enemy_r;
		int enemy_b;
		int enemy_g;
		char[] str;
		
		if ( enemy_atk >= (enemy_atk + enemy_def + enemy_spd )/3 )
		{
			enemy_r = 255;
		}
		else
		{
			enemy_r = 0;
		}
		if ( enemy_def >= (enemy_atk + enemy_def + enemy_spd )/3 )
		{
			enemy_b = 255;
		}
		else
		{
			enemy_b = 0;
		}
		if ( enemy_spd >= (enemy_atk + enemy_def + enemy_spd )/3 )
		{
			enemy_g = 255;
		}
		else
		{
			enemy_g = 0;
		}
		

			k = map[map_lock];				//敵レベル設定
			Hell_drawRect( sx -4 , sy -4
				, 32 +8, 32 +8, 0, 0, 	cast(int)(k*10+0), 255*get[map_lock], 155-k*5, 200);	//MAP枠
//			str = std.string.format( "AREA%01d%01d", map_lock % 5 +1 , map_lock / 5 +1);
			str = std.string.format( "AREA%02d", map_lock  +1);
			Hell_drawFont( str , sx +40, sy , 1.5 , 255,255,255);	//xy
		if ( get[map_lock]== 1)				//鎮圧完了
		{
			Hell_drawTexture("enemy"			//敵表示 標準
			, sx 
			, sy 
			, 32 * enemy_type
			, 32 * 2
			, 32 , 32
			, 1.0, 1.0
			, 0
			,enemy_r, enemy_g, enemy_b, 100 );
			Hell_drawFont( "TARGET"  ,  sx -10, sy + 5 , 1 , 255,255,100);
			Hell_drawFont( "SEALED"  ,  sx - 5, sy +20 , 1 , 255,255,100);
		}
		else
		{
		Hell_drawTexture("enemy"			//敵表示 標準
		, sx 
		, sy 
		, 32 * enemy_type
		, 32 * 2
		, 32 , 32
		, 1.0, 1.0
		, 0
		,enemy_r, enemy_g, enemy_b, 255 );
			
		}
		Hell_drawFont( "LV "  ,  sx +50, sy +20 , 1.5 , 200,200,255);
		str = std.string.format( "%02d", enemy_lv );				
		Hell_drawFont( str ,  sx +80, sy+ 20 , 1.5 , 200,200,255);
			
	}


	void text_draw( int sx , int sy ) 		//MAP SELECT
	{
		int j;
		int k;
		char[] str;

		
		if ( Hell_GetGameflag(10) == 16 )
		{
			Hell_drawFont( "TEXT"  , 200 , sy-20 , 1.5 ,	 255,0,0);
			Hell_drawFont( "STORY"  			, 200,  sy      , 1.5 , 100,100,200);
			Hell_drawFont( "How to"		 		, 200,  sy + 22 , 1.5 , 100,100,200);
//			Hell_drawFont( "RECORD" 			, 200,  sy + 42 , 1.5 , 100,100,200);
//			Hell_drawFont( "" 					, 200,  sy + 62 , 1.5 , 100,100,200);
//			Hell_drawFont( ""					, 200,  sy + 82 , 1.5 , 100,100,200);
//			Hell_drawFont( "RESET"				, 200,  sy +102 , 1.5 , 100,100,200);
		}
		if ( Hell_GetGameflag(10) == 17 )
		{
		Hell_drawRect( sx -5,  80 -20,
				40, 20+ 100 +20,
				0, 0, 
				0, 100, 100, 
				200);						//TEXT延長枠
		}

		if ( ( text_p == 1 ) && ( Hell_GetGameflag(10) == 17 ) )
		{
			Hell_drawFont( "STORY"  			, sx,  sy , 1.5 , 100,255,255);
			Hell_drawFont( "The enemy escaped" 	, sx,  sy +20 , 1.0 , 255,255,255);
			Hell_drawFont( "from the labyrinth" , sx,  sy +30 , 1.0 , 255,255,255);
			Hell_drawFont( "of time." 			, sx,  sy +40 , 1.0 , 255,255,255);
			Hell_drawFont( "Please discover the", sx,  sy +50 , 1.0 , 255,255,255);
			Hell_drawFont( "enemy of targets." 	, sx,  sy +60 , 1.0 , 255,255,255);
			Hell_drawFont( "And seal it."	 	, sx,  sy +70 , 1.0 , 255,255,255);
		}
		if ( ( text_p == 2 ) && ( Hell_GetGameflag(10) == 17 ) )
		{
			Hell_drawFont( "How to play"  		, sx,  sy , 1.5 , 100,255,255);
			Hell_drawFont( "1 area select"		, sx,  sy +20 , 1.0 , 255,255,255);
			Hell_drawFont( "2 timer setting" 	, sx,  sy +30 , 1.0 , 255,255,255);
			Hell_drawFont( "3 timer start" 		, sx,  sy +40 , 1.0 , 255,255,255);
			Hell_drawFont( "seeks for the " 	, sx,  sy +55 , 1.0 , 255,255,255);
			Hell_drawFont( "enemy of targets." 	, sx,  sy +65 , 1.0 , 255,255,255);
		}
		if ( ( text_p == 3 ) && ( Hell_GetGameflag(10) == 17 ) )
		{
		}

		if ( ( 200 < Hell_getMouseX ) && ( 200 +100 > Hell_getMouseX ) 
		 &&  ( 80   < Hell_getMouseY ) && ( 80 +20*2  > Hell_getMouseY )
		 && ( Hell_GetGameflag(10) == 16 ) )
		{
			Hell_drawRect( 200 , ( ( Hell_getMouseY  ) /20 )*20 
				          , 100 , 16, 1, 0, 	255, 255, 0, 255);	//カーソル
		}
		else if ( Hell_GetGameflag(10) != 17 )
		{
			Hell_SetGameflag( 10 , 10 );
		}
		
	}


	

	void arms_draw( int sx , int sy) 		//SELECT arms
	{
		int j;
		int k;
		int l;
		int arms_atk0;
		int arms_def0;
		int arms_spd0;
		int arms_type0;
		int arms_r0;
		int arms_b0;
		int arms_g0;
		char[] str;
		
		Hell_drawRect( sx - 2 , sy - 2
			, 15*10+4 , 16 +4, 0, 0, 	0, 100, 100, 100);		//arms_BG枠
		
		for ( j = 0 ; j <= 9 ; j++ )
		{	
			if ( arms[j] > 0)
			{
			arms_type0 = (arms[j] /1000) % 100 -1;
			arms_atk0 = (arms[j] /100) % 10 *10;
			arms_def0 = (arms[j] /10 ) % 10 *10;
			arms_spd0 = (arms[j] /1  ) % 10 *10;
			
			
			
				if ( arms_atk0 >= (arms_atk0 + arms_def0 + arms_spd0 )/3 )
				{
					arms_r0 = 255;
				}
				else
				{
					arms_r0 = 0;
				}
				if ( arms_def0 >= (arms_atk0 + arms_def0 + arms_spd0 )/3 )
				{
					arms_b0 = 255;
				}
				else
				{
					arms_b0 = 0;
				}
				if ( arms_spd0 >= (arms_atk0 + arms_def0 + arms_spd0 )/3 )
				{
					arms_g0 = 255;
				}
				else
				{
					arms_g0 = 0;
				}
				
				
			Hell_drawTexture("player"			//武器表示 標準
			, sx + 15 *j
			, sy 
			, 32 * arms_type0
			, 32 * 14
			, 32 , 32
			, 0.5, 0.5
			, 0
			,arms_r0, arms_g0, arms_b0, 255 );
				
				if ( ( sx < Hell_getMouseX ) && ( sx +150 > Hell_getMouseX ) 
				 &&  ( sy < Hell_getMouseY ) && ( sy +16 > Hell_getMouseY ) 
				 && ( (Hell_getMouseX - sx)/15 == j) && (arms[(Hell_getMouseX - sx)/15 ] != 0) )
//				 && (arms_lock == j))
				{
					Hell_drawRect( 160-40 , 150-5					//ARMS決定枠
						, 80, 80, 0, 0, 	0, 100, 100, 100);		
					Hell_drawTexture("player"						//ARMS確定中
					, 160 -32
					, 150 
					, 32 * arms_type0
					, 32 * 14
					, 32 , 32
					, 2, 2
					, 0
					,arms_r0, arms_g0, arms_b0, 250 );

					Hell_drawFont( "L select"  , 210, 220 , 1.5 , 100,255,100);
					
					if ( ( count == 0 ) && ((Hell_getMouseX -20) /15 == arms_lock ) && (arms_lock > 0) )
					{
					Hell_drawFont( "R absorb"  , 210, 230 , 1.5 , 255,100,100);
					}
					if ( ( player_act == 4 ) && ((Hell_getMouseX -10) /15 == arms_lock ) && (arms_lock > 0) )
					{
//					Hell_drawFont( "R shot"  , 210, 230 , 1.5 , 255,100,100);
					}
						
				Hell_drawRect( 170, 200 , (arms[j] /100) % 10 *5 , 4, 0, 0, 	255, 100, 100, 255);	//ATK

				Hell_drawRect( 170, 205 , (arms[j] /10) % 10  *5 , 4, 0, 0, 	100, 100, 255, 255);	//DEF

				Hell_drawRect( 170, 210 , (arms[j] /1) % 10   *5 , 4, 0, 0, 	100, 255, 100, 255);	//SPD

//				str = std.string.format( "A%01d", (arms[j] /100) % 10 );				
//				Hell_drawFont( str ,  170 , 190 , 1 , 200,0,0);
//				str = std.string.format( "D%01d", (arms[j] / 10) % 10 );				
//				Hell_drawFont( str ,  173 , 200 , 1 , 0,0,200);
//				str = std.string.format( "S%01d", (arms[j] /  1) % 10 );				
//				Hell_drawFont( str ,  176 , 210 , 1 , 0,200,0);
				}

				
			}
		}
		
		Hell_drawRect( sx + (arms_lock * 15)-1 , sy-1
			, 16 +2, 16 +2, 1, 0, 	255, 0, 0, 255);		//ARMS確定カーソル
		
		if ( ( sx < Hell_getMouseX ) && ( sx +150 > Hell_getMouseX ) 
		 &&  ( sy < Hell_getMouseY ) && ( sy +16 > Hell_getMouseY ) )
		{
			Hell_drawRect( Hell_getMouseX - ( ( Hell_getMouseX - sx )% 15)-1 ,Hell_getMouseY - ( ( Hell_getMouseY - sy )% 16)-1
				          , 16+2 , 16+2, 1, 0, 	255, 255, 0, 255);	//ARMS選択カーソル
			Hell_SetGameflag( 10 , 15 );
			if (arms_lock == j)
			{
			Hell_drawTexture("player"			//武器表示 標準
			, 160 -32
			, 150 
			, 32 * arms_type0
			, 32 * 14
			, 32 , 32
			, 2, 2
			, 0
			,arms_r0, arms_g0, arms_b0, 250 );

			}
		}
	}


	void absorb_draw() 		//absorb effect
	{
		float j;
		int arms_atk0;
		int arms_def0;
		int arms_spd0;
		int arms_type0;
		int arms_r0;
		int arms_b0;
		int arms_g0;
		
			arms_type0 = (arms[10] /1000) % 100 -1;
			arms_atk0 = (arms[10] /100) % 10 *10;
			arms_def0 = (arms[10] /10 ) % 10 *10;
			arms_spd0 = (arms[10] /1  ) % 10 *10;
			
			j = cast(float)absorb_count / 200;
		
			if ( arms_atk0 >= (arms_atk0 + arms_def0 + arms_spd0 )/3 )
			{
				arms_r0 = 255;
			}
			else
			{
				arms_r0 = 0;
			}
			if ( arms_def0 >= (arms_atk0 + arms_def0 + arms_spd0 )/3 )
			{
				arms_b0 = 255;
			}
			else
			{
				arms_b0 = 0;
			}
			if ( arms_spd0 >= (arms_atk0 + arms_def0 + arms_spd0 )/3 )
			{
				arms_g0 = 255;
			}
			else
			{
				arms_g0 = 0;
			}
			
			
//			Hell_drawRect( 160 - cast(int)(16* j) ,130 - cast(int)(16* j)
//				          , cast(int)(32* j) , cast(int)(32* j), 1, 0, 	255, 255, 255, absorb_count);	//ARMS選択カーソル
			
			Hell_drawTexture("player"								//ARMS枠1
			, 160 -16* j*1.5
			, 130 -16* j*1.5
			, 32 * 12
			, 32 * 0
			, 32 , 32
			, j*1.5, j*1.5
			, 360+absorb_count
			,255, 255, 255, absorb_count );
		
			Hell_drawTexture("player"								//ARMS枠2
			, 160 -16* j*1.7
			, 130 -16* j*1.7
			, 32 * 13
			, 32 * 0
			, 32 , 32
			, j*1.7, j*1.7
			, 360-absorb_count
			,255, 255, 255, absorb_count );
		
			Hell_drawTexture("player"								//ARMS吸収中
			, 160 -16* j
			, 130 -16* j
			, 32 * arms_type0
			, 32 * 14
			, 32 , 32
			, j, j
			, 0
			,arms_r0, arms_g0, arms_b0, absorb_count );
					
	}

	//-----------------------------------------------------------------------------
	//	エフェクトの作成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void create_effect( int type, float x, float y, float dir, float speed, int r, int g, int b )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist == 0 )
			{
				effect[i].exist = 1;	//存在
				effect[i].type = type;	//
				effect[i].timer = 0;	//生存時間
				effect[i].pos_x = x;	//位置
				effect[i].pos_y = y;	//位置
				effect[i].alpha = 255;	//透明度
				effect[i].dir = dir;	//
				effect[i].speed = speed;	//
				
				//タイプによってパラメータを分けるといいかも
				effect[i].r = r;	//色
				effect[i].g = g;	//色
				effect[i].b = b;	//色
				effect[i].zoom_x = 0.3;	//拡大率
				effect[i].zoom_y = 0.3;	//拡大率
				break;
			}
		}
	}
	//エフェクトの表示
	void effect_draw( )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist != 0 )
			{
				//種類を増やす場合はtypeで処理をわける
				Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
				Hell_drawTextureEx("effect"
					, effect[i].pos_x
					, effect[i].pos_y
					, 0
					, 0
					, 128, 128
					, effect[i].zoom_x , effect[i].zoom_y
					, 0
					,effect[i].r, effect[i].g, effect[i].b, effect[i].alpha );
			}
		}
		Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す
	}
	//エフェクトの移動
	void effect_move( )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist != 0 )
			{
				effect[i].timer++;	//生存時間

				float vx = Hell_sinEx( effect[i].dir ) * effect[i].speed;
				float vy = Hell_cosEx( effect[i].dir ) * effect[i].speed;
				effect[i].pos_x += vx;	//位置
				effect[i].pos_y += vy;	//位置

				//種類を増やす場合はtypeで処理をわける
				effect[i].zoom_x -= 0.01;	//
				effect[i].zoom_y -= 0.01;	//
				if ( effect[i].zoom_x < 0.0 )
				{
					effect[i].zoom_x = 0.0;
				}
				if ( effect[i].zoom_y < 0.0 )
				{
					effect[i].zoom_y = 0.0;
				}

				effect[i].alpha -= 8;	//透明度
				if ( effect[i].alpha < 0 )
				{
					effect[i].exist = 0;	//消える 
				}
			}
		}
	}



}





/* LogoMain ********************************************************************/
/*	ロゴの状態																	*/
/********************************************************************************/

class LogoMain : GameState
{
public:
	int timer;
	Keypad keypad;					// キーボード/ゲームパッド取得用
	int init_flag;
	
	this()
	{
		setMsg( GameState.MSG_NONE );
		timer = 0;
		init_flag = 0;
		
		keypad = new Keypad();
//		menu = new ClickablePool();
//		menu.add("START" , new Vec3(280 , 400 , 0) , new Vec3(96 , 32 , 0));
		
	}
	
	void move()
	{
		if ( init_flag == 0 )
		{
			init_flag = 1;
			Hell_loadTexture("logo","resource/image/logo.bmp" , [0,255,0]);
		}
		timer++;
		
		if ( ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) )|| ( timer > 180 ) )
		{
//			Hell_playBgm( "resource/sound/99.ogg" );
			setMsg(GameState.MSG_REQ_TITLE);
			//１ボタン
		}
	}
	
	void draw()
	{
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		Hell_drawRect( 0, 0,
				320 , 240,
				0, 0, 
				0, 0, 100, 
				255);							//window枠

		Hell_drawTexture("logo"
			, 5
			, 0
			, 0
			, 0
			, 320 , 320
			, 1 , 1
			, 0 );
				
	}
}

