﻿/********************************************************************************/
/* 	gamecore.d																	*/
/*------------------------------------------------------------------------------*/
/*	製作		D.K（あるふぁ～秘密基地）										*/
/*	製作開始	2008/05/22														*/
/*	MAIL		dk@red.interq.or.jp												*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2008/05/22	初版ベースファイル　tamakoro D.K（あるふぁ～秘密基地）									*/
/*	2019/10/06	瓦千鳥　競技用に改造												*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

private import state;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;
private import clickable;
//private import configparser;

import config;

//private import std.math;

/********************************************************************************/

//ConfigParser configparser = null;
const static string CONFIG_PATH = "config.ini";


/* GameMain *********************************************************************/
/*	ゲーム本体の状態															*/
/********************************************************************************/

class GameMain : GameState
{
public:
	//-----------------------------------------------------------------------------
	//システム制御用
	//-----------------------------------------------------------------------------
	enum SCENE{
		INIT = 0,
		START,
		MAIN,
		CLEAR,
		END,
		PAUSE,
		RELESE,
		
		//以下ゲーム内の演出
		PLAYER_WARP,
		ENEMY_GETWAIT,
		PLAYER_MISSWAIT,

		EXIT,
	};
	

	ConfigParser savedata;			// セーブデータ

	int timer;						// 汎用タイマー
	SCENE iSceneStatus;				//画面の状態
	int stage;						// ステージ
	int stage_start_count;			// ステージ開始処理
	int stage_clear_count;			// ステージ開始処理
	int game_score = 0;				//スコア
	int hi_score = 0;				//ハイスコア
	int game_time_count = 0;		//ゲーム終了までの残り時間
	int menu_input = 0;				//敵を倒したときのWAITカウンタ

	int drive = 0;					//進んだ距離
	int power = 0;					//パワーメータ
	int speed = 0;					//スピード



	//-----------------------------------------------------------------------------
	//190923 ゲーム別に使用される特別処理用変数
	//-----------------------------------------------------------------------------
	float obs_size = 1.0;	//test用
	int l_leg = 0;			//左足カウント
	int r_leg = 0;			//右足カウント	
	float dash_speed = 0;	//加速スピード
	
	
	int core_x = 120;		//キャラ表示座標
	int core_y = 240;		//キャラ表示座標
	float zoome =6;			//マップのズーム　アニメサイズ
	int player_size = 32;	//キャラのサイズ
	int player_act = 0;		//主人公_状態
	int player_ani = 0;		//主人公_アニメフレーム
	int anime_count = 10;	//主人公_アニメ速度用
	int spd = 15;			//アニメスピード
	int ani_count = 0;		//アニメカウンタ
	int ani_frame = 0;		//変化フレーム数
	int floor[1100];		//足場情報
	int map_x = 5;			//足場位置
	int map_ani = 0;		//足場移動距離
	int jump_flag = 0;      //ジャンプボタン用フラグ
	int player_jump = 0;	//ジャンプエナジー
	int player_y = 0;		//ジャンプ用y軸
	int slide_count = 0;	//スライディング時間
	int slide_flag = 0;		//スライディング用flag
	int stone_count = 0;	//硬直時間
	
	int loop_j;						//汎用ループ
	int loop_k;						//汎用ループ
	int loop_m;						//汎用ループ



	
	Keypad keypad;					// キーボード/ゲームパッド取得用
	//-----------------------------------------------------------------------------
	//ゲーム別に使用される特別処理用変数
	//-----------------------------------------------------------------------------

	//-----------------------------------------------------------------------------
	//	コンストラクタ
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	this()
	{
		setMsg( GameState.MSG_NONE );
		// 各種初期化
		timer = 0;

		savedata          = new ConfigParser();
		keypad = new Keypad();
		keypad.SetUseCancel( false );

		iSceneStatus = SCENE.INIT;

	}

	
	//-----------------------------------------------------------------------------
	//	シーンの初期化
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void init( )
	{
Hell_write( "Gamecoer init\n" );
		//リソースの読み込み
		Hell_loadTexture("tama","resource/image/tama.bmp" , [0,255,0]);
		Hell_loadTexture("aira","resource/image/player.bmp" , [0,255,0]);
		Hell_loadTexture("map","resource/image/bg.bmp" , [0,255,0]);

		Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);

		Hell_loadWAV("get",         "resource/sound/l1.wav");
		Hell_loadWAV("slide",         "resource/sound/atk1.wav");
		Hell_loadWAV("door",        "resource/sound/puwa.wav");
		Hell_loadWAV("damage",        "resource/sound/damage.wav");
		Hell_loadWAV("select",        "resource/sound/select.wav");
		Hell_loadWAV("destroy",        "resource/sound/destroy2.wav");
		Hell_loadWAV("powerup",        "resource/sound/clear.wav");
		Hell_loadWAV("landing",        "resource/sound/landing.wav");

		//セーブデータ
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HI_SCORE",         999);
			savedata.set("HOSHI",         1);
			savedata.write();
		}
		hi_score = savedata.getint("HI_SCORE");

		game_time_count = 0;		//ゲーム終了までの残り時間
		drive = 0;					//進んだ距離
		
		//■とりあえず足場配置
		for ( loop_j = 1 ; loop_j < 1000 ; loop_j++ )	//床マップ配置(初期配置型)
		{
			
			
			floor[ loop_j ] = 0;
			if ( loop_j % 20 == 0 )
			{
				floor[ loop_j ] = 1;	//1段ブロック
			}
			if ( loop_j % 50 == 0 )
			{
				floor[ loop_j ] = 2;	//2段ブロック
			}
			if ( loop_j % 80 == 0 )
			{
				floor[ loop_j ] = 3;	//下段抜けブロック
			}
			
			
			//D言語くん
			if ( loop_j >= 450 )
			{
				if ( ( loop_j % 20 == 0 ) && ( Hell_randInt(0, 4) == 0) )
				{
					floor[ loop_j ] = 5;	//1段ブロック
				}
				if ( ( loop_j % 50 == 0 ) && ( Hell_randInt(0, 4) == 0) )
				{
					floor[ loop_j ] = 6;	//2段ブロック
				}
				if ( ( loop_j % 80 == 0 ) && ( Hell_randInt(0, 4) == 0) )
				{
					floor[ loop_j ] = 7;	//下段抜けブロック
				}
			}
			
			//ランダム仕様バージョン テスト用
			//競技では条件を公平にするため使用しない
			if ( loop_j % 10 == 0 )
			{
			//	floor[ loop_j ] = Hell_randInt(0, 4);
			}
			
			
			
		}
			floor[ 0 ] = 0;
			floor[800] = 4;			//とりあえずゴール

Hell_write( "Gamecoer init\n" );

		iSceneStatus = SCENE.START;
	}
	


	//-----------------------------------------------------------------------------
	//	シーンの後処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void relese( )
	{
		iSceneStatus = SCENE.EXIT;
	}
	//-----------------------------------------------------------------------------
	//	開始演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_move( )
	{
		int i;

		if ( stage_start_count < ( 60 * 3 ) )
		{
			stage_start_count++;
		}
		else 
		{
			Hell_playBgm( "resource/sound/pp_battle04.ogg", -1, 0 );
			iSceneStatus = SCENE.MAIN;
			stage_start_count = 0;
		}
	}
	//-----------------------------------------------------------------------------
	//	ステージ開始表示処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_draw( )
	{
		if ( stage_start_count > ( 60 * 2 ) )
		{
			Hell_drawFont(" GO! " , 240, 200 , 4 , 255,255,255);
		}
		else
		{
			Hell_drawFont("READY" , 240, 200 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_move( )
	{
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			//if(Hell_isPushMouse() & HELL_BUTTON_LEFT)
			if( keypad.isPushEnter(true) )
			{
				iSceneStatus = SCENE.RELESE;
			}
		}
		else 
		{
			stage_clear_count++;
		}
		
		
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の表示
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;

		Hell_setAlpha(HELL_ALPHA_NORMAL);
//		Hell_drawFont( "HI SCORE" , 400, 10 , 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( hi_score ) , 400, 30 , 4 , 255,255,255);

		Hell_drawFont( "RESULTS" , 200, 250 , 4 , 255,255,255);

		min = ( game_score / 60 ) / 60;
		sec = ( game_score / 60 ) % 60;
		msec = game_score % 60;
		str = std.string.format( "%02d:%02d:%02d", min, sec, msec );

		Hell_drawFont( "TIME" ,    210, 300 , 2 , 255,255,255);
		Hell_drawFont( str , 220, 320 , 4 , 255,255,255);
		if ( hi_score >= game_score )
		{
			Hell_drawFont( "NEW RECORD",170, 190 , 4 , 255,0,0);
		}

		if ( stage_clear_count > ( 60 * 2 ) )
		{
			Hell_drawFont("PRESS Z OR 1 BUTTON TO EXIT" , 100, 440 , 2 , 255,255,255);
		}
		else
		{
			Hell_drawFont(" GOAL !" , 200, 420 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲームオーバー演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneEnd( )
	{
//		iSceneStatus = SCENE.MAIN;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move()
	{
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			init( );
			break;
		case SCENE.START:
			//開始
			SeneStart_move( );
			break;
		case SCENE.MAIN:
			keypad.update( );	//リプレイキー入力の更新
			//メイン
			system_move( );

			break;
		case SCENE.CLEAR:
			//クリア
			SeneClear_move( );
			break;
		case SCENE.END:
			//ゲームオーバー
			break;
		case SCENE.PAUSE:
			//一時停止
			pause_move( );
			break;
		case SCENE.RELESE:
			//後処理
			relese( );
			break;

		case SCENE.EXIT:
		default:
			//シーンの終了
			setMsg(GameState.MSG_REQ_TITLE);
			break;
		}
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw()
	{
		// 作画開始
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			break;
		case SCENE.START:
			//開始
			map_draw( );		//■
			player_draw( );		//■
			system_draw( );

			SeneStart_draw( );
			break;
		case SCENE.MAIN:
			//メイン
			map_draw( );		//■
			player_draw( );		//■
			system_draw( );
		//	obstacle_draw( );	//■
			break;
		case SCENE.CLEAR:
			//クリア
			map_draw( );		//■
			player_draw( );		//■
			system_draw( );
			SeneClear_draw( );
			break;
		case SCENE.END:
			//ゲームーバー
			system_draw( );
			SeneEnd( );
			break;
		case SCENE.PAUSE:
			//一時停止
			system_draw( );
			pause_draw( );
			break;
		case SCENE.RELESE:
			//後処理
			break;
			
			
		case SCENE.EXIT:
		default:
			break;
		}
// for debug code start
Hell_drawFPS( 550, 10 );
//Hell_drawFont( std.string.toString( cast( int )scroll_status ), 10, 10 * 1, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )position.y ), 10, 10 * 2, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )place ), 10, 10 * 3, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )motion ), 10, 10 * 4, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )debug_disp[0] ), 10, 10 * 5, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )jump_fream_count ), 10, 10 * 6, 1 , 255,255,255 );
// for debug code end

	}
	
	// 画面サイズ取得
	int getScreenWidth(){return boot.g_width;}
	int getScreenHeight(){return boot.g_height;}
	
	string zfill(string str , int n)
	{
		for(int t=str.length;t<n;t++){
			str = "0" ~ str;
		}
		return str;
	}
	
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_move( )
	{
		//残り時間のカウント
		game_time_count++;

		//■test

		 if(Hell_isPushMouse() & HELL_BUTTON_LEFT)
		 {
			obs_size = obs_size + .2;
		 }
		 if(Hell_isPushMouse() & HELL_BUTTON_RIGHT)
		 {
			obs_size = obs_size - .2;
		 }

		//■プレイヤーACTフラグ
		player_act = 0;		//ニュートラル
		//■足踏みダッシュL
		 if( (keypad.isPushEnter())  && ( player_y == 0 ) )
		 {
		 	if(keypad.isPushCancel())
		 	{
		 	}
		 	else
		 	{
				if ( l_leg == 0 )
				{
				l_leg = 1;
				r_leg = 0;
				player_act = 1;						//走る
				}
			}
		 }
		 //■足踏みダッシュR
		 if( (keypad.isPushCancel())   && ( player_y == 0 ) )
		 {
		 	if(keypad.isPushEnter())
		 	{
		 	}
		 	else
		 	{
				if ( r_leg == 0 )
				{
				l_leg = 0;
				r_leg = 1;
				player_act = 1;						//走る
				}
			}
		 }
		 //■ジャンプ
 		 if((keypad.isPushUp()) && ( slide_count ==0 ) )
			{
			if ( jump_flag == 0)
				{
					Hell_playWAV( "door", 0, -1 );
					jump_flag = 1;
					player_act = 11;				//ジャンプ
					player_jump = 12;				//ジャンプエナジー
				}
			}
			if (player_y >0 )
			{
					player_act = 11;				//ジャンプ
			}
			
			 //■スライディング
 		 if( (keypad.isPushDown()) && ( player_act != 11) )
			{
			if ( slide_flag == 0)
				{
					Hell_playWAV( "slide", 0, -1 );
					slide_flag = 1;
					player_act = 12;				//スライディング
					slide_count = 15;				//スライディング時間
				}
			}
		if (slide_count >0 )
			{
					slide_count = slide_count - 1;
					player_act = 12;
			}
			else
			{
					slide_flag = 0;
					//jump_flag = 0;
			}
			
		//■フラグ毎のアクション
		
		if (player_act == 1 )								//■走る
		{
			dash_speed = dash_speed + 3;		//加速
			
			if ( dash_speed < 50 )
			{
				Hell_playWAV( "landing", 0, -1 );
			}
			if ( dash_speed > 70 )
			{
				dash_speed = 70;				//リミッター　解除すると難易度上昇します。
			}
		}
		else
		{
			//減速負荷
			dash_speed = dash_speed - 0.1;
			if ( dash_speed < 0 )
			{
				dash_speed = 0;
			}
		}
		if ( (player_act == 0 ) && ( dash_speed >0 ) )		//■走る0 加速中はニュートラルでも走る扱い。
		{
			player_act = 1;
		}
		
		if (player_act == 11 )								//■ジャンプ
		{
			player_y = player_y + player_jump;
			player_jump = player_jump - 1;
			if ( player_y == 0)
			{
			jump_flag = 0;
			player_act = 1;
			}
		}
		if ( stone_count > 0)								//ダメージ硬直
		{
			stone_count = stone_count -1;
			player_act = 6;
		}
		
		drive = drive + cast( int )dash_speed;					//進む
		map_x =   cast(int)(drive / 256 );		
		map_ani = cast(int)(drive % 256 )/8;		
        
        anime_count = anime_count - cast( int )( dash_speed / 10 ) - 1;
        if (anime_count < 0)
        {
        	anime_count = 8;
        	player_ani = player_ani + 1;
        	if (player_ani > 5 )
        	{
        	player_ani= 0;
        	}
        }

		//マップズーム計算
			zoome = 6 - ( dash_speed / 12 );
			if ( dash_speed >45 )
			{
			zoome = 2 ;
			}
		
		//■衝突判定
		if ( ( floor[map_x] == 1 ) && ( player_y < 32 ) )
		{
			Hell_playWAV( "damage", 0, -1 );
			dash_speed = dash_speed / 2;
			drive = drive + 50;
			player_act = 6;
			stone_count = 15;
		}
		if ( ( floor[map_x] == 2 ) && ( player_y < 64 ) )
		{
			Hell_playWAV( "damage", 0, -1 );
			dash_speed = dash_speed / 2;
			drive = drive + 50;
			player_act = 6;
			stone_count = 15;

		}
		if ( ( floor[map_x] == 3 ) && ( slide_flag == 0 ) )
		{
			Hell_playWAV( "damage", 0, -1 );
			dash_speed = dash_speed / 2;
			drive = drive + 50;
			player_act = 6;
			stone_count = 15;
		}


		if ( ( floor[map_x] == 5 ) && ( player_y < 32 ) )
		{
			Hell_playWAV( "damage", 0, -1 );
			dash_speed = dash_speed / 2;
			drive = drive + 50;
			player_act = 6;
			stone_count = 15;
		}
		if ( ( floor[map_x] == 6 ) && ( player_y < 64 ) )
		{
			Hell_playWAV( "damage", 0, -1 );
			dash_speed = dash_speed / 2;
			drive = drive + 50;
			player_act = 6;
			stone_count = 15;

		}
		if ( ( floor[map_x] == 7 ) && ( slide_flag == 0 ) )
		{
			Hell_playWAV( "damage", 0, -1 );
			dash_speed = dash_speed / 2;
			drive = drive + 50;
			player_act = 6;
			stone_count = 15;
		}


		if ( drive >= 205000 )
		{
			
			Hell_playBgm( "resource/sound/results.ogg", 1, 0 );

			//ハイスコアの保存
			game_score = game_time_count;
			if ( hi_score > game_score )
			{
				keypad.save( "replay/replay_01.bin" );	//リプレイの保存
				hi_score = game_score;
				savedata.set("HI_SCORE",   cast(int)hi_score);
				savedata.write();
			}

			iSceneStatus = SCENE.CLEAR;
		}
		
		if ( iSceneStatus == SCENE.MAIN )
		{
			if(keypad.isPushCancel(true))
			{
				//ポーズ
//				iSceneStatus = SCENE.PAUSE;
//				menu_input = 0;
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	■2019ゲーム情報、システムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void obstacle_draw( )
	{
		
		Hell_drawTexture("tama"
			, drive
			, 200
			, 0
			, 0
			, 64, 64
			, obs_size , obs_size
			, 360 - ( drive % 360 )
			,255, 255, 255, 255 );
		
		
	
	}
	//-----------------------------------------------------------------------------
	//	■2019ゲーム情報、システムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void map_draw( )
	{
		
		Hell_setAlpha(HELL_ALPHA_NORMAL);		//まずは足場
		if ( map_x >5 )
		{ 
		loop_m = -5;
		}
		else
		{
		loop_m = 0;
		}
		for ( loop_j = loop_m ; loop_j < 30 ; loop_j++ )	//敵マップ配置(初期配置型)
		{
		Hell_drawTexture("map"								
			, core_x - zoome - ( player_size / 2 * zoome ) + ( player_size * loop_j * zoome ) - map_ani *zoome
			, core_y - zoome - ( player_size / 2 * zoome ) + ( player_size * -2 * zoome )
			, 0  + floor[map_x + loop_j] * 32
			, 0
			, 32 ,128
			, zoome , zoome
			, 0
			,255, 255, 255, 255 );
		}
		
	}
	
	//-----------------------------------------------------------------------------
	//	■2019ゲーム情報、システムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void player_draw( )		
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		if ( (stone_count % 2) == 0 )
		{
		Hell_drawTexture("aira"
			, core_x - zoome - ( player_size / 2 * zoome )
			, core_y - zoome - ( player_size / 2 * zoome ) - player_y * 1 * zoome
			, player_size * player_ani
			, player_size * player_act
			, player_size , player_size
			, zoome , zoome
			, 0
			,255, 255, 255, 255 );
		}
		
	}


	
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;
		int r = 255;
		int g = 255;
		int b = 255;
		
		
/*		
		Hell_drawTexture("tama"
			, drive * 640 / 10000
			, 200
			, 0
			, 0
			, 64, 64
			, 1.0 , 1.0
			, 360 - ( drive % 360 )
			,255, 255, 255, 255 );
*/
		
/*		
		Hell_drawFont( "POWER" , 170, 130 , 2 , 255,255,255);
		Hell_drawRect( 170 - 2, 150 - 2, 300 + 4, 10 + 4, 0, 0, 255, 255, 255, 255);
		Hell_drawRect( 170, 150, 300, 10, 0, 0, 0, 0, 0, 255);
		if ( power > 0 )
		{
			Hell_drawRect( 170, 150, cast( int )power, 10, 0, 0, 0, 255, 0, 255);
		} 
*/		
		
		
		
		
		
		
		min = ( game_time_count / 60 ) / 60;
		sec = ( game_time_count / 60 ) % 60;
		msec = game_time_count % 60;
		
		if ( iSceneStatus != SCENE.CLEAR )
		{
			str = std.string.format( "TIME %02d:%02d:%02d", min, sec, msec );
		}
		
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawFont( str , 150, 100 , 3 , r,g,b);

//		Hell_drawFont( "SCORE" , 10, 10 , 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( game_score ) , 10, 30 , 4 , 255,255,255);

		min = ( hi_score / 60 ) / 60;
		sec = ( hi_score / 60 ) % 60;
		msec = hi_score % 60;

		Hell_drawFont( "HI SCORE" , 300, 10 , 2 , 255,255,255);
		str = std.string.format( "%02d:%02d:%02d", min, sec, msec );
		Hell_drawFont( str , 300, 30 , 4 , 255,255,255);

		//■コース進行状況
//		Hell_drawFont( "COURSE" , 170, 400 , 2 , 255,255,255);
		Hell_drawRect( 170 - 0,420 - 0, 300 + 0, 10 + 4, 0, 0, 255, 255, 255, 255);
		Hell_drawRect( 170, 410, 300, 20, 0, 0, 0, 0, 0, 255);

		Hell_drawTexture("aira"
			, 175 - .5 - ( player_size / 2 * .5 ) + ( drive /700 )
			, 420 - .5 - ( player_size / 2 * .5 ) 				//- player_y * 1 * .5
			, player_size * player_ani
			, player_size * 1
			, player_size , player_size
			, .5 , .5
			, 0
			,255, 255, 255, 255 );
		
		//■加速ゲージ
		Hell_drawFont( "SPEED" , 170, 360 , 2 , 255,255,255);
		Hell_drawRect( 170 - 2, 380 - 2, 300 + 4, 10 + 4, 0, 0, 255, 255, 255, 255);
		Hell_drawRect( 170, 380, 300, 10, 0, 0, 0, 0, 0, 255);
		if ( dash_speed > 1 )
		{
			Hell_drawRect( 170, 380, cast( int )dash_speed *4, 10, 0, 0, 0, 100, 255, 255);
		} 
		
//		Hell_drawFont( std.string.toString( cast( int )dash_speed ) , 10, 30 , 4 , 255,255,255);	//デバッグ用
//		Hell_drawFont( std.string.toString( cast( int )map_x ) , 10, 30 , 4 , 255,255,255);			//デバッグ用
//		Hell_drawFont( std.string.toString( cast( int )player_y ) , 10, 60 , 4 , 255,255,255);		//デバッグ用
//		Hell_drawFont( std.string.toString( cast( int )jump_flag ) , 10, 90 , 4 , 255,255,255);		//デバッグ用
//		Hell_drawFont( std.string.toString( cast( int )drive ) , 10, 90 , 4 , 255,255,255);			//デバッグ用
	
	}
	
	//-----------------------------------------------------------------------------
	//	ポーズの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_move( )
	{
		if(keypad.isPushUp(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input++;
			if ( menu_input > 1 )
			{
				menu_input = 0;
			}
		}
		else if(keypad.isPushDown(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input--;
			if ( menu_input < 0 )
			{
				menu_input = 1;
			}
		}
		if(keypad.isPushEnter(true))
		{
			switch ( menu_input )
			{
			case 0:
				//ポーズ解除
				iSceneStatus = SCENE.MAIN;
				break;
			case 1:
				//リトライ
				iSceneStatus = SCENE.RELESE;
				break;
			default:
				break;
			}
		}
		if(keypad.isPushCancel(true))
		{
			//ポーズ解除
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTexture("menu"
			, 96 + 160
			, 64 + 120 + ( menu_input * 32 )
			, 320
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawTexture("menu"
			, 160
			, 120
			, 0
			, 0
			, 320, 240
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
	}
	
	
}


